package com.bcxin.sp.config.aspect;

import com.bcxin.sp.config.annotation.SysManageAuth;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.GlobalConst;
import com.bcxin.sp.work.util.HttpContextUtils;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.lang.reflect.Method;


/**
 */
@Aspect
@Component
public class SysManageAuthAspect {


	@Pointcut("@annotation(com.bcxin.sp.config.annotation.SysManageAuth)")
	public void logPointCut() { 
		
	}

	@Around("logPointCut()")
	public Object around(ProceedingJoinPoint joinPoint) throws Throwable {
		MethodSignature signature = (MethodSignature) joinPoint.getSignature();
		Method method = signature.getMethod();

		SysManageAuth sysManageAuthAn = method.getAnnotation(SysManageAuth.class);
		String limitRole = sysManageAuthAn.limitRole();

		//获取request
		HttpServletRequest request = HttpContextUtils.getHttpServletRequest();
		//用户名
		Object obj = request.getSession().getAttribute(GlobalConst.LOGIN_USER);
		if (obj != null) {
			User user = (User) obj;
			if (limitRole.equals(user.getRole())) {
				return new ModelAndView("/error/userNoAuth");
			}
		}
		//执行方法
		Object result = joinPoint.proceed();
		return result;
	}

}
