package com.bcxin.sp.config.interceptor;



import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
/*

      配置bim离线部署解析离线包中的gz压缩包
 */

@WebFilter(filterName = "BimOfflineFilter",urlPatterns = "*.gz")
public class BimOfflineFilter implements Filter {
    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain)
            throws IOException, ServletException {
        HttpServletResponse response = (HttpServletResponse) servletResponse;
        //告诉响应头以gzip格式解码,启用浏览器gzip解压
        response.setCharacterEncoding("UTF-8");
        response.setHeader("Content-Encoding", "gzip");
        response.setContentType("application/json;charset=utf-8");
        try {
            filterChain.doFilter(servletRequest, servletResponse);
        } catch (ServletException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void destroy() {

    }
}
