package com.bcxin.sp.work.controller.activity.equipment;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.dto.CameraDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.third.shanma.CommunicateService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;

/**
 * 设备管理
 */
@Controller
@RequestMapping("/business/deviceCamera")
@Slf4j
public class DeviceCameraController extends BaseController {

    @Resource
    private CommunicateService communicateService;


    /** 安保态势 **/

    /**
     * <b> 视频设备信息 </b>
     * @author ZXF
     * @create 2020/04/23 0023 16:09
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("spsbList/{activityNo}")
    public ModelAndView spsbList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/abts/spsbList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findSpsbListData")
    @ResponseBody
    public SearchDto<CameraDTO> findSpsbListData(SearchDto<CameraDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = communicateService.findSpsbListData(dto);
        List<CameraDTO> resultList = (List<CameraDTO>)pageResult.getRows();
        SearchDto<CameraDTO> result = new SearchDto<CameraDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

}
