package com.bcxin.sp.work.controller.activity.extend;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityEmergencyPlan;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.activity.extend.ActivityEmergencyPlanService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 应急预案管理
 */
@Controller
@RequestMapping("/business/emergencyPlan")
@Slf4j
public class ActivityEmergencyPlanController extends BaseController {

    @Resource
    private ActivityEmergencyPlanService activityEmergencyPlanService;

    /**
     * <b> 根据活动查询应急预案 </b>
     * @author ZXF
     * @create 2020/02/28 0028 15:09
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("findActivityEmergencyPlanList/{activityId}")
    public @ResponseBody List<Map> findActivityEmergencyPlanList(@PathVariable("activityId") Long activityId) throws Exception {
        return activityEmergencyPlanService.findActivityEmergencyPlanListByActivityId(activityId);
    }

    /** 安保态势 **/

    /**
     * <b> 应急处理预案信息 </b>
     * @author ZXF
     * @create 2020/04/23 0023 16:09
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("yjclyaList/{activityNo}")
    public ModelAndView cggdList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/abts/yjclyaList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findYjclyaListData")
    @ResponseBody
    public SearchDto<ActivityEmergencyPlan> findYjclyaListData(SearchDto<ActivityEmergencyPlan> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = activityEmergencyPlanService.findYjclyaListData(dto);
        List<ActivityEmergencyPlan> resultList = (List<ActivityEmergencyPlan>)pageResult.getRows();
        SearchDto<ActivityEmergencyPlan> result = new SearchDto<ActivityEmergencyPlan>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }
}
