/**
 * date: 2020-04-26 15:40
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.controller.activity.extend;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityGather;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.accident.ActivityGatherSearchDTO;
import com.bcxin.sp.work.service.third.activityIsr.ActivityGatherService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author: wangjianjun
 * @description:活动战果信息
 * @data: 2020-04-26 15:40
 **/
@Controller
@RequestMapping("/business/activityGather")
@Slf4j
public class ActivityGatherController extends BaseController {

    @Resource
    private ActivityGatherService activityGatherService;

    /**
     * 活动战果信息－页面
     *
     * @param
     * @return
     */
    @RequestMapping("/activityGatherListView/{activityNo}")
    public ModelAndView jqsjListView(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/extend/activityGatherList");
        index.addObject("activityNo", activityNo);
        return index;
    }

    /**
     * 活动战果信息-列表
     *
     * @param dto
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findActivityGatherListData")
    @ResponseBody
    public SearchDto<ActivityGather> findActivityGatherListData(ActivityGatherSearchDTO dto) {
        PageResult pageResult = activityGatherService.findActivityGatherList(dto);
        List<ActivityGather> resultList = (List<ActivityGather>) pageResult.getRows();
        SearchDto<ActivityGather> result = new SearchDto<>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

//    /**
//     * 活动战果信息－详情-页面
//     *
//     * @param
//     * @return
//     */
//    @RequestMapping("/activityGatherDetailView/{activityNo}")
//    public ModelAndView jqsjDetailView(@PathVariable("activityNo") String activityNo) {
//        ModelAndView index = new ModelAndView("/activity/extend/ActivityGatherDetail");
//        index.addObject("gather", findActivityPoliceGatherDetailData(activityNo));
////        index.addObject("activityNo", activityNo);
//        return index;
//    }

    /**
     * 活动战果信息-详情
     *
     * @param id
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("/findActivityGatherDetailData/{id}")
    @ResponseBody
    public ActivityGather findActivityPoliceGatherDetailData(@PathVariable("id") Long id, HttpServletRequest request) {
        return activityGatherService.selectByPrimaryKey(id);
    }
}