/**
 * date: 2020-04-26 15:40
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.controller.activity.isr;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.isr.ActivityIsr;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.accident.ActivityIsrSearchDTO;
import com.bcxin.sp.work.service.third.activityIsr.ActivityIsrService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: wangjianjun
 * @description:
 * 情报研判信息
 * @data: 2020-04-26 15:40
 **/
@Controller
@RequestMapping("/business/activityIsr")
@Slf4j
public class ActivityIsrController extends BaseController {

    @Resource
    private ActivityIsrService activityIsrService;

    /**
     *
     * 情报研判信息－页面
     *
     * @param activityNo
     * @return
     */
    @RequestMapping("/activityIsrListView/{activityNo}")
    public ModelAndView jqsjListView(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/isr/activityIsrList");
        index.addObject("activityNo", activityNo);
        return index;
    }

    /**
     *
     * 情报研判信息-列表
     * @param dto
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findActivityIsrListData")
    @ResponseBody
    public SearchDto<ActivityIsr> findActivityIsrListData(ActivityIsrSearchDTO dto) {
        PageResult pageResult = activityIsrService.findActivityIsrList(dto);
        List<ActivityIsr> resultList = (List<ActivityIsr>) pageResult.getRows();
        SearchDto<ActivityIsr> result = new SearchDto<>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     *
     * 情报研判信息-详情
     * @param id
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findActivityIsrDetailData")
    @ResponseBody
    public ActivityIsr findActivityPoliceIsrDetailData(String id) {
        return activityIsrService.findActivityIsrDetail(Long.valueOf(id));
    }
}