/**
 * date: 2020-04-26 15:40
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.controller.activity.isr;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.isr.ActivityPoliceIsr;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.accident.ActivityPoliceIsrrSearchDTO;
import com.bcxin.sp.work.service.third.activityIsr.ActivityPoliceIsrService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: wangjianjun
 * @description: 警情
 * @data: 2020-04-26 15:40
 **/
@Controller
@RequestMapping("/business/activityPoliceIsr")
@Slf4j
public class ActivityPoliceIsrController extends BaseController {

    @Resource
    private ActivityPoliceIsrService activityPoliceIsrService;

    /**
     * 警情数据－页面
     *
     * @param activityNo
     * @return
     */
    @RequestMapping("/jqsjListView/{activityNo}")
    public ModelAndView jqsjListView(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/isr/activityPoliceIsrList");
        index.addObject("activityNo", activityNo);
        return index;
    }

    /**
     * 警情数据-列表
     * @param dto
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findJqsjListData")
    @ResponseBody
    public SearchDto<ActivityPoliceIsr> findActivityPoliceIsrListData(ActivityPoliceIsrrSearchDTO dto) {
        PageResult pageResult = activityPoliceIsrService.findPoliceIsrList(dto);
        List<ActivityPoliceIsr> resultList = (List<ActivityPoliceIsr>) pageResult.getRows();
        SearchDto<ActivityPoliceIsr> result = new SearchDto<>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     * 警情数据-详情
     * @param id
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findJqsjDetailData/{id}")
    @ResponseBody
    public ActivityPoliceIsr findActivityPoliceIsrDetailData(@PathVariable("id") Long id) {
        return activityPoliceIsrService.findPoliceIsr(id);
    }
}