/**
 * date: 2020-04-26 15:40
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.controller.activity.other;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.base.Aircraft;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.accident.AircraftSearchDTO;
import com.bcxin.sp.work.service.third.activityIsr.AircraftService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: wangjianjun
 * @description: 飞行器，低慢小
 * @data: 2020-04-26 15:40
 **/
@Controller
@RequestMapping("/business/aircraft")
@Slf4j
public class AircraftController extends BaseController {

    @Resource
    private AircraftService aircraftService;

    /**
     * 低慢小－页面
     *
     * @param activityNo
     * @return
     */
    @RequestMapping("/aircraftListView/{activityNo}")
    public ModelAndView jqsjListView(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/other/aircraftList");
        index.addObject("activityNo", activityNo);
        return index;
    }

    /**
     * 低慢小-列表
     *
     * @param dto
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("/findAircraftListData")
    @ResponseBody
    public SearchDto<Aircraft> findAircraftListData(AircraftSearchDTO dto) {
        PageResult pageResult = aircraftService.findAirCraftList(dto);
        List<Aircraft> resultList = (List<Aircraft>) pageResult.getRows();
        SearchDto<Aircraft> result = new SearchDto<>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     * 低慢小-详情
     *
     * @param id
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("/findAircraftDetailData/{id}")
    @ResponseBody
    public Aircraft findActivityPoliceIsrDetailData(@PathVariable("id") Long id) {
        return aircraftService.findAircraftDetail(id);
    }
}