package com.bcxin.sp.work.controller.activity.ticket;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.dto.ActivityPersonDTO;
import com.bcxin.sp.work.entity.dto.ActivityPersonStaffDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.activity.ticket.TicketService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;

/**
 * 票证态势管理
 */
@Controller
@RequestMapping("/business/ticket")
@Slf4j
public class TicketController extends BaseController {

    @Resource
    private TicketService ticketService;


    /**
     * <b> 制证信息 </b>
     * @author ZXF
     * @create 2020/04/23 0023 16:09
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("zzList/{activityNo}")
    public ModelAndView zzList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/pz/zzList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findZzListData")
    @ResponseBody
    public SearchDto<ActivityPersonStaffDTO> findZzListData(SearchDto<ActivityPersonStaffDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = ticketService.findZzListData(dto);
        List<ActivityPersonStaffDTO> resultList = (List<ActivityPersonStaffDTO>)pageResult.getRows();
        SearchDto<ActivityPersonStaffDTO> result = new SearchDto<ActivityPersonStaffDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     * <b> 发售票信息 </b>
     * @author ZXF
     * @create 2020/04/23 0023 16:09
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("fspList/{activityNo}")
    public ModelAndView fspList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/pz/fspList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findFspListData")
    @ResponseBody
    public SearchDto<ActivityPersonDTO> findFspListData(SearchDto<ActivityPersonDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = ticketService.findFspListData(dto);
        List<ActivityPersonDTO> resultList = (List<ActivityPersonDTO>)pageResult.getRows();
        SearchDto<ActivityPersonDTO> result = new SearchDto<ActivityPersonDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }
}
