package com.bcxin.sp.work.controller.log;

import cn.hutool.core.util.ObjectUtil;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.log.OperateLog;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.OperateLogSearchDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.log.OperateLogService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.StringUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Controller
@RequestMapping("/operate/log")
@Slf4j
public class OperateLogController extends BaseController {

    @Autowired
    OperateLogService operateLogService;

    @RequestMapping("list")
    public ModelAndView operateList(HttpServletRequest request) throws Exception {
        ModelAndView view = new ModelAndView("/log/operateList");
        return view;
    }


    @RequestMapping("findData")
    @ResponseBody
    public SearchDto<OperateLog> findData(OperateLogSearchDTO dto, HttpServletRequest request) throws Exception {
        User user = super.getCurrentUser(request);
        if(user.getRegionLevel() == 1) {
            dto.setProvince(user.getProvince());
        } else if(user.getRegionLevel() == 2) {
            dto.setProvince(user.getProvince());
            dto.setCity(user.getCity());
        } else if(user.getRegionLevel() == 3) {
            dto.setProvince(user.getProvince());
            dto.setCity(user.getCity());
            dto.setArea(user.getArea());
        }
        if(ObjectUtil.equal(user.getRole(),DictConst.ROLE_SUPERADMIN)
            || ObjectUtil.equal(user.getRole(),DictConst.ROLE_ADMIN)
                || ObjectUtil.equal(user.getRole(),DictConst.ROLE_ADMIN_APPROVE)) {
            // 如果是管理员，可以看到所有
        }else {
            dto.setUserId(user.getId());
        }
        // 设置时间
        if(StringUtil.isNotEmpty(dto.getStartDate())){
            dto.setStartDate(dto.getStartDate()+" 00:00:00");
        }
        if(StringUtil.isNotEmpty(dto.getEndDate())){
            dto.setEndDate(dto.getEndDate()+" 23:59:59");
        }

        List<OperateLog> list = operateLogService.searchLog(dto);
        long count = operateLogService.searchLogCount(dto);
        PageResult pageResult=new PageResult(list,count);
        SearchDto<OperateLog> result = new SearchDto<OperateLog>();
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        result.setData(list);
        return result;
    }
}
