package com.bcxin.sp.work.controller.sys;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bcxin.sp.config.cache.CacheUtils;
import com.bcxin.sp.config.exception.BusinessException;
import com.bcxin.sp.config.redis.RedisUtils;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.GlobalConst;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Controller;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Controller
@Slf4j
public class BaseController {

	@Resource
	private RedisUtils redisUtils;

	public User getCurrentUser(HttpServletRequest request) {
		User user= (User)request.getSession().getAttribute(GlobalConst.LOGIN_USER);
		if(user == null){
			String access_token = request.getParameter("access_token");
			if(StringUtils.isNotEmpty(access_token)){
				System.out.println("======> 访问token:"+access_token);
				String obj = (String)redisUtils.get(access_token);
				System.out.println("======> 访问token.obj:"+obj==null?null: obj);
				User dbUser = JSONObject.parseObject(obj,User.class);
				//日期对不上也不行
				if(dbUser != null &&DateUtil.today().equals(dbUser.getLoginDay())){
					user = dbUser;
					request.getSession().setAttribute(GlobalConst.LOGIN_USER,user);
				}else{
					throw new BusinessException("token无效，请重新登录!");
				}
			}
		}
		return user;
	}


	/**
	 * 获取当前请求对象
	 * @return
	 */
	public HttpServletRequest getRequest(){
		try{
			HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();
			return request;
		}catch(Exception e){
			return null;
		}
	}
	/**
	 * 获取当前请求对象
	 * @return
	 */
	public HttpServletResponse getResponse(){
		try{
			return ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getResponse();
		}catch(Exception e){
			return null;
		}
	}

}
