package com.bcxin.sp.work.controller.sys;

import com.bcxin.sp.config.annotation.SysManageAuth;
import com.bcxin.sp.work.entity.domain.sys.CSMsgTemplate;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.service.sys.CSMsgTemplateService;
import com.bcxin.sp.work.util.Const.DictConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;

/**
 * 行政服务，设置通知承办方去哪办理许可
 */
@Controller
@RequestMapping("/business/primaryNotice")
public class CSMsgTemplateController extends BaseController {

    @Autowired
    private CSMsgTemplateService CSMsgTemplateService;

    @RequestMapping("/init")
    @SysManageAuth(limitRole = DictConst.ROLE_APPROVE)
    public ModelAndView list(HttpServletRequest request) {
        ModelAndView view = new ModelAndView("/csMsgTemplate");
        User user = super.getCurrentUser(request);
        CSMsgTemplate CSMsgTemplate = CSMsgTemplateService.findPrimaryNoticeByArea(user);
        view.addObject("primaryNotice", CSMsgTemplate);
        return view;
    }

    @RequestMapping("createOrUpdate")
    public @ResponseBody
    AjaxResult createOrUpdate(CSMsgTemplate CSMsgTemplate, HttpServletRequest request) throws ParseException {
        User user = super.getCurrentUser(request);
        CSMsgTemplate.setUpdater(user.getUsername());
        if ( CSMsgTemplate.getId() == null) {
            CSMsgTemplateService.save(CSMsgTemplate,user);
        } else {
            CSMsgTemplateService.update(CSMsgTemplate);
        }
        AjaxResult result = new AjaxResult();
        result.setSuccessful(true);
        result.setObj(CSMsgTemplate);
        return result;
    }

    @RequestMapping("enable")
    public @ResponseBody
    AjaxResult enable(HttpServletRequest request) throws ParseException {
        String id = request.getParameter("id");
        CSMsgTemplate CSMsgTemplate = CSMsgTemplateService.findById(Long.parseLong(id));
        CSMsgTemplate.setActive(DictConst.Y);
        CSMsgTemplateService.update(CSMsgTemplate);
        AjaxResult result = new AjaxResult();
        result.setSuccessful(true);
        result.setObj(CSMsgTemplate);
        return result;
    }

    @RequestMapping("freeze")
    public @ResponseBody
    AjaxResult freeze(HttpServletRequest request) throws ParseException {
        String id = request.getParameter("id");
        CSMsgTemplate CSMsgTemplate = CSMsgTemplateService.findById(Long.parseLong(id));
        CSMsgTemplate.setActive(DictConst.N);
        CSMsgTemplateService.update(CSMsgTemplate);
        AjaxResult result = new AjaxResult();
        result.setSuccessful(true);
        result.setObj(CSMsgTemplate);
        return result;
    }

}
