package com.bcxin.sp.work.controller.sys;

import cn.hutool.core.util.StrUtil;
import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.entity.domain.sys.Message;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.sys.MessageService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 * 消息管理
 * </p>
 *
 * @author 罗鹏
 * @date 2018/5/17
 */
@Controller
@RequestMapping("/business/message")
@Slf4j
public class MessageController extends BaseController {

    @Resource
    private MessageService messageService;

    @RequestMapping("/list")
    public ModelAndView list(HttpServletRequest request) {
        ModelAndView view = new ModelAndView("/sys/message");
        view.addObject("status",request.getParameter("status"));
        return view;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.XXGL_WDXX)
    @RequestMapping("findData")
    @ResponseBody
    public SearchDto<Message> findData(SearchDto<Message> dto,HttpServletRequest request) throws Exception {
        User user = super.getCurrentUser(request);
        dto.setUserId(user.getId());

        List<Message> messageList = messageService.searchMessage(dto);
        long count = messageService.searchCountOfMessage(dto);
        SearchDto<Message> result = new SearchDto<Message>();
        result.setData(messageList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(count);
        result.setITotalDisplayRecords(count);
        return result;
    }


    /**
     * 设置消息已读
     *
     * @param request
     * @return
     * @throws Exception
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.XXGL_WDXX_YD)
    @RequestMapping("read")
    @ResponseBody
    public String read(HttpServletRequest request) throws Exception {
        String messageId = request.getParameter("messageId");
        if (StrUtil.isEmpty(messageId)) {
            return "";
        }
        messageService.read(messageId);
        return "1";
    }

}
