package com.bcxin.sp.work.controller.sys;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.entity.domain.sys.ServiceOrg;
import com.bcxin.sp.work.entity.dto.ServiceOrgSearchDto;
import com.bcxin.sp.work.service.sys.ServiceOrgService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

/**
 * 服务机构
 */

@Controller
@RequestMapping("/business/serviceOrg")
public class ServiceOrgController extends BaseController {

    @Autowired
    private ServiceOrgService serviceOrgService;
    /**
     * 报备列表
     * @return
     */
    @RequestMapping("/list")
    public ModelAndView list() {
        ModelAndView view = new ModelAndView("/sys/serviceOrg");
        return view;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.TJZX_FWSML_XQ)
    @RequestMapping("/orgPreview/{orgId}")
    public ModelAndView orgPreview(@PathVariable Long orgId) {
        ModelAndView view = new ModelAndView("/sys/dialog/orgPreview");
        ServiceOrg serviceOrg= serviceOrgService.findById(orgId);
        view.addObject("org",serviceOrg);
        return view;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.TJZX_FWSML)
    @RequestMapping("search")
    public @ResponseBody
    ServiceOrgSearchDto search(ServiceOrgSearchDto dto) throws Exception {
        return serviceOrgService.search(dto);
    }
}
