package com.bcxin.sp.work.controller.third.nx;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.nx.NxParamDTO;
import com.bcxin.sp.work.service.third.nx.NXDataService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import java.util.List;

/**
 * 宁夏数据
 */
@Controller
@RequestMapping("/business/nx")
@Slf4j
public class NXDataController extends BaseController {

    @Resource
    private NXDataService nxDataService;


    /**
     * <b> 人员移动盘查信息 </b>
     */
    @RequestMapping("ryydpcList/{activityNo}")
    public ModelAndView ryydpcList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/abts/ryydpcList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findRyydpcListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findRyydpcListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findRyydpcListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 相关场所盘查信息 </b>
     */
    @RequestMapping("xgcspcxxList/{activityNo}")
    public ModelAndView xgcspcxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/abts/xgcspcxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findXgcspcxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findXgcspcxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findXgcspcxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     * <b> 涉会企业基本信息 </b>
     */
    @RequestMapping("shqyjbxxList/{activityNo}")
    public ModelAndView shqyjbxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/abts/shqyjbxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findShqyjbxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findShqyjbxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findShqyjbxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }



    /**
     * <b> 人员居住证明信息 </b>
     */
    @RequestMapping("ryjzzmxxList/{activityNo}")
    public ModelAndView ryjzzmxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/ryjzzmxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findRyjzzmxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findRyjzzmxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findRyjzzmxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 治安人员过闸信息 </b>
     */
    @RequestMapping("zarygzxxList/{activityNo}")
    public ModelAndView zarygzxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/zarygzxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findZarygzxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findZarygzxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findZarygzxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 人员汽车票信息 </b>
     */
    @RequestMapping("ryqcpxxList/{activityNo}")
    public ModelAndView ryqcpxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/pz/ryqcpxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findRyqcpxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findRyqcpxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findRyqcpxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     * <b> 人员_情报_全国在逃人员信息 </b>
     */
    @RequestMapping("qgztryxxList/{activityNo}")
    public ModelAndView qgztryxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/qgztryxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findQgztryxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findQgztryxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findQgztryxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }



    /**
     * <b> 人员_情报_全国重点人员信息表 </b>
     */
    @RequestMapping("qgzdryxxList/{activityNo}")
    public ModelAndView qgzdryxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/qgzdryxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findQgzdryxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findQgzdryxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findQgzdryxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 人员_情报_全国刑事犯罪前科人员信息 </b>
     */
    @RequestMapping("qgxsfzqkryxxList/{activityNo}")
    public ModelAndView qgxsfzqkryxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/qgxsfzqkryxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findQgxsfzqkryxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findQgxsfzqkryxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findQgxsfzqkryxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 人员_情报_全国涉稳人员信息 </b>
     */
    @RequestMapping("qgswryxxList/{activityNo}")
    public ModelAndView qgswryxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/qgswryxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findQgswryxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findQgswryxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findQgswryxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 人员_情报_全国涉恐人员信息 </b>
     */
    @RequestMapping("qgskryxxList/{activityNo}")
    public ModelAndView qgskryxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/ryts/qgskryxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findQgskryxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findQgskryxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findQgskryxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }


    /**
     * <b> 车辆_治安_全国被盗抢机动车信息 </b>
     */
    @RequestMapping("qgbdqjdcxxList/{activityNo}")
    public ModelAndView qgbdqjdcxxList(@PathVariable("activityNo") String activityNo) {
        ModelAndView index = new ModelAndView("/activity/workbench/clts/qgbdqjdcxxList");
        index.addObject("activityNo",activityNo);
        return index;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findQgbdqjdcxxListData")
    @ResponseBody
    public SearchDto<NxParamDTO> findQgbdqjdcxxListData(SearchDto<NxParamDTO> dto) throws Exception {
        /* 查出所有的记录 */
        PageResult pageResult = nxDataService.findQgbdqjdcxxListData(dto);
        List<NxParamDTO> resultList = (List<NxParamDTO>)pageResult.getRows();
        SearchDto<NxParamDTO> result = new SearchDto<NxParamDTO>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

}
