package com.bcxin.sp.work.controller.third.zj;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.service.third.zj.ZJDataService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

/**
 * 浙江上报部级数据
 */
@Controller
@RequestMapping("/business/zj")
@Slf4j
public class ZJDataController extends BaseController {

    @Resource
    private ZJDataService zjDataService;


    /**
     * <b> 活动信息上报部级接口 </b>
     * @author ZXF
     * @create 2025/01/15 0015 10:35
     * @version
     * @注意事项 </b>
     */
    @AuditLogAn(operateType = DictConst.OP_SAVE,menuName = MenuConst.HDGL_BAHD_TJHD)
    @RequestMapping("/uploadaction/{activityId}")
    public @ResponseBody
    AjaxResult uploadaction(@PathVariable("activityId") Long activityId, HttpServletRequest request) {
        User user = super.getCurrentUser(request);
        return zjDataService.uploadaction(user, activityId);
    }

}
