package com.bcxin.sp.work.controller.upgrade;

import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.domain.upgrade.SystemUpgradeUser;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.service.upgrade.SystemUpgradeUserService;
import com.bcxin.sp.work.util.Const.DictConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;

/**
 * @author hzp
 */
@Controller
@RequestMapping("/business/upgrade")
public class SystemUpgradeUserController extends BaseController {

    @Autowired
    private SystemUpgradeUserService upgradeUserService;

    /**
     * 保存升级信息读取记录
     * @param request
     * @param upgradeId
     */
    @RequestMapping("/save/{upgradeId}")
    @ResponseBody
    public AjaxResult saveUpgradeUser(HttpServletRequest request, @PathVariable("upgradeId") Long upgradeId){
        AjaxResult result=new AjaxResult();
        User user = super.getCurrentUser(request);
        SystemUpgradeUser upgradeUser=new SystemUpgradeUser();
        upgradeUser.setIsRead(DictConst.Y);
        upgradeUser.setReadTime(new Date());
        upgradeUser.setUpgradeId(upgradeId);
        upgradeUser.setUserId(user.getId());
        upgradeUserService.insert(upgradeUser);
        result.setSuccessful(true);
        return result;
    }
}
