package com.bcxin.sp.work.controller.user;

import com.bcxin.sp.work.controller.bi.BiController;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.domain.upgrade.SystemUpgrade;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.service.upgrade.SystemUpgradeService;
import com.bcxin.sp.work.service.upgrade.SystemUpgradeUserService;
import com.bcxin.sp.work.service.user.PCService;
import com.bcxin.sp.work.service.user.UserService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

@Controller
@RequestMapping("/business/pc")
public class PCController extends BaseController {

    @Resource
    private PCService pcService;

    @Resource
    private SystemUpgradeService systemUpgradeService;
    @Resource
    private SystemUpgradeUserService systemUpgradeUserService;

    @Resource
    private UserService userService;

    @Resource
    private BiController biController;

    @RequestMapping("/index")
    public ModelAndView list(HttpServletRequest request, String type) {
        ModelAndView index = new ModelAndView("/index");
        HttpSession session = request.getSession();
        if (type == null) {
            if (session.getAttribute("myType") == null) {
                type = "sp";
            }
            else {
                type = session.getAttribute("myType").toString();
            }
        }
        if (type != null) {
            if ("ab".equals(type)) {
                index = biController.dxhdsy(request);
            }
            else if ("sp".equals(type)) {
                index = new ModelAndView("/index");
            }
            else if ("zdhd".equals(type)) {
                index = biController.zdabsy(request);
            }
            session.setAttribute("myType", type);
        }
        if("ningxia".equalsIgnoreCase(ConfigUtil.getValue("envi"))){
            index = new ModelAndView("/index");
        }
        User user = super.getCurrentUser(request);
        index.addObject("messageTotal", pcService.messageTotal(user));
        //在添加电话配置功能后，判断是否第一次登录
        if (DictConst.ROLE_ADMIN.equals(user.getRole())) {
            if (!DictConst.N.equals(user.getFirstLogin())) {
                if (user.getRegionLevel() == 2 || user.getRegionLevel() == 3) {
                    index.addObject("firstLogin", "1");
                }
                user.setFirstLogin("0");
                userService.createOrUpdate(user);
            }
        }

        // 增加系统升级提示
        SystemUpgrade systemUpgrade = systemUpgradeService.findUpgrade();
        if (systemUpgrade != null) {
            boolean flag = systemUpgradeUserService.checkUpgradeWithUser(user.getId(), systemUpgrade.getId());
            if (!flag) {
                systemUpgrade.setContent(systemUpgrade.getContent().replace("\r\n", ""));
                index.addObject("systemUpgrade", systemUpgrade);
                index.addObject("showUpgrade", "true");
            }
        }
        return index;
    }

}
