package com.bcxin.sp.work.controller.user.zj;

import cn.hutool.core.lang.Console;
import com.bcxin.sp.config.exception.BusinessException;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.service.third.nxzw.NxSJGJService;
import com.bcxin.sp.work.service.user.zj.PlatCommunicateService;
import com.bcxin.sp.work.util.StringUtil;
import com.bcxin.sp.work.util.WebUtil;
import com.bcxin.sp.work.util.zj.JwtUtil;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * 浙江SSO单点登录
 * @author 罗鹏
 */
@Controller
@RequestMapping("/zj/sso")
public class UserSSOController extends BaseController {

    @Resource
    private PlatCommunicateService platCommunicateService;

    @Resource
    private NxSJGJService nxSJGJService;

    /**
     * 警综登录
     * @param request
     * @return
     */
    @RequestMapping("/zj/login")
    public String zjLogin(HttpServletRequest request) {
       /* String key = request.getParameter("key");
        Console.log("得到警综单点的参数：key =" + key);
        if (StringUtil.isEmpty(key)) {
            throw new BusinessException("获取浙江警综平台登录秘钥失败，请重新登录");
        }
        *//* 调用统一认证接口服务，验证token是否有效 *//*
        platCommunicateService.jzTokenValidateNew(request,key);*/

        String appToken=request.getHeader("RZZX-APPTOKEN");
        String userToken=request.getHeader("RZZX-USERTOKEN");
        if(StringUtil.isEmpty(appToken)||StringUtil.isEmpty(userToken)) {
        appToken=request.getParameter("RZZX-APPTOKEN");
        userToken=request.getParameter("RZZX-USERTOKEN");
        }
        if(StringUtil.isEmpty(appToken)||StringUtil.isEmpty(userToken)) {
            throw new BusinessException("获取用户令牌、应用令牌失败，请重新登录");
        }
        platCommunicateService.jzTokenValidateNew(appToken,userToken);
        return "redirect:/business/pc/index";
    }

    /**
     * 治综登录对接
     * @param request
     * @return
     */
    @GetMapping("/zz/login")
    public String zzLogin(HttpServletRequest request) {
        Map<String, String> requestMap = WebUtil.getParameterMap(request);
        Console.log("得到治综单点的参数：");
        Console.log(requestMap.toString());
        String sessionId = requestMap.get("sessionId");
        if (StringUtil.isEmpty(sessionId)) {
            throw new BusinessException("获取浙江治综平台登录秘钥失败，请重新登录");
        }
        /* 调用统一认证接口服务，验证token是否有效 */
        platCommunicateService.zzTokenValidateNew(request,sessionId);
        return "redirect:/business/pc/index";
    }

    @RequestMapping("/register/{oid}")
    @ResponseBody
    public String registerqq(@PathVariable String oid, HttpServletRequest request) {
        try {
            JwtUtil.parseJWT(request.getParameter("token"));
        } catch (Exception e) {
            return e.getMessage();
        }
        nxSJGJService.receive1(Long.parseLong(oid));
        return "1";
    }

}
