package com.bcxin.sp.work.dao.activity.base;


import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.dto.ActivityAnbaoDto;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.SummaryDto;
import com.bcxin.sp.work.entity.dto.SyncTaskDTO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface ActivityMapper extends BaseMapper<Activity> {

	List<ActivityAnbaoDto> findActivityByTime();
	List<ActivityAnbaoDto> findActivityByDay(@Param("day") String day);
	List<ActivityAnbaoDto> findActivityByDayAndNo(@Param("day") String day,@Param("list") List<String> list);
	List<ActivityAnbaoDto> findActivityByDayAndNotNo(@Param("day") String day,@Param("list") List<String> list);

	List<Activity> findActivity(SearchDto searchDto);

	Activity findFullById(@Param("activityId") Long activityId);

	Map getActivityById(@Param("activityId") Long activityId);

	List<Activity> findActivityByUser(SearchDto searchDto);

    List<Map> findActivityByApproveLevel(@Param("approveLevel") String approveLevel);

	long findCountOfActivity(SearchDto searchDto);

	long findCountByWorkflowVersion(@Param("version") String version);
	
	List<Activity> findNeedRepairWorkflowVersion(@Param("province") String province,
												 @Param("city")String city, @Param("area")String area);

	long findCountOfActivityByUser(String condition, Long userId);

	void repairActivitySync();

	void repairApproval2SL();

	void updateActivityReContent(@Param("activityId") Long activityId,
								 @Param("approveStatus") String approveStatus,@Param("reContent") String reContent);

	List<SummaryDto> findSummary(String condition);

	List<SyncTaskDTO> findNeedSyncTask(@Param("province") String province,
									   @Param("city")String city, @Param("area")String area);

	List<Activity> findNeedSyncActivity(@Param("approveLevel") String approveLevel, @Param("province") String province,
										@Param("city")String city, @Param("area")String area);

	List<Activity> findAllNeedSyncActivity();

	List<Activity> findNeedPrimarySyncActivity(@Param("approveLevel") String approveLevel, @Param("province") String province,
											   @Param("city")String city, @Param("area")String area);

	List<Activity> findAllNeedPrimarySyncActivity();

	List<Activity> findNeedWorkflowActivity(String province);

    Activity findActivityForApproveUser(Long activityId);

    List<Map> findActivityApproveUser(@Param("activityId") Long activityId);

	/**
	 * 获取审批用户
	 * @param activityId
	 * @return
	 */
	List<Map> findApproveUser(@Param("activityId") Long activityId);

	List<Map> findAlreadyApproveUser(@Param("activityId") Long activityId);

    Map approvalSummary(@Param("province") String province,
						@Param("city")String city, @Param("area")String area,@Param("regionLevel")int regionLevel);

	Map approvalFinalSummary(@Param("province") String province,
							 @Param("city")String city, @Param("area")String area,
							 @Param("beginDate")String beginDate, @Param("endDate")String endDate,@Param("regionLevel")int regionLevel);

	Map approvalTodaySummary(@Param("province") String province,
							 @Param("city")String city, @Param("area")String area,@Param("regionLevel")int regionLevel);

	void clearArea(@Param("activityId") Long activityId);

	/**
	 * <b> 根据活动编码查询活动id </b>
	 * @author ZXF
	 * @create 2020/02/27 0027 13:45
	 * @version
	 * @注意事项 </b>
	 */
	Long getIdByActivityNo(@Param("activityNo") String activityNo);

	Activity findLastActivity(@Param("province") String province,@Param("city")String city, @Param("area")String area);

	//是否补充完材料
	void updateActivityByIsAddFiles(@Param("activityId") Long activityId,@Param("pssId") Long pssId,@Param("isAddFiles") String isAddFiles);
}
