package com.bcxin.sp.work.dao.sys;


import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.bcxin.sp.work.entity.domain.sys.Message;
import com.bcxin.sp.work.entity.dto.SearchDto;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface MessageMapper extends BaseMapper<Message> {

    /**
     * 查找消息列表，根据用户
     * @param userId
     * @param offset 从哪条开始
     * @param rows 每页多少条
     * @return
     */
    List<Message> findMessageByUser(@Param("userId")Long userId, @Param("offset")int offset, @Param("rows")int rows);

    /**
     * 查找用户的消息条数
     * @param userId
     * @return
     */
    Long findCountOfMessage(@Param("userId")Long userId);

    /**
     * 查找用户的消息条数
     * @param userId
     * @return
     */
    Long findStatusCountOfMessage(@Param("userId")Long userId,@Param("readStatus")String readStatus);

    List<Message> searchMessage(SearchDto<Message> dto);

    Long searchCountOfMessage(SearchDto<Message> dto);
}
