package com.bcxin.sp.work.entity.domain.activity.approve;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Data
@TableName("sp_approve")
public class Approve extends Model<Activity> {

	private static final long serialVersionUID = -7088672083348697781L;

	@TableId(type = IdType.AUTO)
	private Long id;
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date addTime = new Date();
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date updateTime = new Date();
	private String updater = "system";

	private Integer seq;
	/*
	 "10":初审
	 "20":受理
	 "30":审批
	*/
	private String approveType;
	private Long activityId;
	private Long userId;
	private String approve;
	private String securityOrg;
	/**
	 * 逻辑删除，默认为0
	 */
	private String logicDel = "0";

	/**
	 * 是否是有效审批（0 不是，1是）
	 */
	private String isActive = "1";

	/*------- 安全风险等级评定相关 --------*/
	/**
	 * 等级评定
	 */
	private String gradeRank;
	/**
	 * 安全等级评定通知书
	 */
	private String rankFile;
	/**
	 * 安全等级说明
	 */
	private String rankComments;
	/*------- 安全风险等级评定相关 --------*/

	@TableField(exist = false)
	private List<ApproveDetail> details = new ArrayList<ApproveDetail>();

	@Override
	protected Serializable pkVal() {
		return this.id;
	}
}
