package com.bcxin.sp.work.entity.domain.activity.expand;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动-临建公司
 */
@Data
@TableName("sp_activity_build")
public class ActivityBuild extends Model<ActivityBuild> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityBuildId;

    /**
     * 活动id
     */
    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityId;

    /**
     * 企业名称
     */
    private String fullName;

    /**
     * 现场负责人
     */
    private String chargeName;

    /**
     * 负责人手机号
     */
    private String chargeMobile;

    /**
     * 全部项
     */
    private String itemTotal;

    /**
     * 待审核项
     */
    private String unApproveItemTotal;

    /**
     * 已通过项
     */
    private String passItemTotal;

    /**
     * 未通过项
     */
    private String failItemTotal;

    /**
     * 已上传文档数
     */
    private String uploadDocTotal;

    /**
     * 更新时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();

    @Override
    protected Serializable pkVal() {
        return this.activityBuildId;
    }

}
