package com.bcxin.sp.work.entity.domain.activity.expand;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 应急处理预案
 */
@Data
@TableName("sp_activity_emergency_plan")
public class ActivityEmergencyPlan extends Model<ActivityEmergencyPlan> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime = new Date();

    /**
     * 活动id
     */
    private Long activityId;

    /**
     * 预案名称
     */
    private String fullName;

    /**
     * 预案类型
     */
    private String emergencyPlanType;

    /**
     * 预案内容
     */
    private String content;

    /**
     * 预案处置任务
     */
    private String dispose;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
