package com.bcxin.sp.work.entity.domain.activity.expand;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动-战果统计
 */
@Data
@TableName("sp_activity_gather")
public class ActivityGather extends Model<ActivityGather> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityGatherId;

    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityId;

    /**
     * 战果编码
     */
    private String gatherNo;

    /**
     * 战果名称
     */
    private String gatherName;

    /**
     * 战果级别
     */
    private String gatherLevel;

    /**
     * 战果详述
     */
    private String description;

    /**
     * 战果日期
     */
    private String gatherDate;

    /**
     * 安保公司编码
     */
    private String securityOrgCode;

    /**
     * 负责机构
     */
    private String securityOrg;

    /**
     * 核查人数
     */
    private String checkCount;

    /**
     * 拦截人数
     */
    private String interceptCount;

    /**
     * 劝返人数
     */
    private String returnCount;

    /**
     * 危险品数量
     */
    private String dangerCount;

    /**
     * 更新时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();

    @Override
    protected Serializable pkVal() {
        return this.activityGatherId;
    }

    /**
     * 活动信息
     */
    private String activityNo;
    private String fullName;
    private String typeCode;
    @JsonSerialize(using = ToStringSerializer.class)
    private Long number;

}
