package com.bcxin.sp.work.entity.domain.activity.expand;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 活动相关材料，比如各审批文书等
 * </p>
 *
 * @author 罗鹏
 * @date 2018/5/23
 */
@Data
@TableName("sp_activity_material")
public class ActivityMaterial extends Model<ActivityMaterial> {

    private static final long serialVersionUID = 7064937058904767154L;

    @TableId(type = IdType.AUTO)
    private Long id;
    private Date addTime = new Date();
    private Date updateTime = new Date();

    private Long activityId;
    /**
     * 报批材料（许可审批材料）
     */
    private String bpcl;
    /**
     * 评估材料
     */
    private String pgcl;
    /**
     * 评估报告
     */
    private String pgbg;
    /**
     * 评估报告出具方
     */
    private String pgbgProvider;
    /**
     * 受理文书
     */
    private String slws;
    /**
     * 监理检查表
     */
    private String jljcb;
    /**
     * 监理报告
     */
    private String jlbg;
    /**
     * 许可决定书
     */
    private String xkjds;
    /**
     * 安全工作方案
     */
    private String aqgzfa;
    /**
     * 安全许可审批表
     */
    private String aqxkspb;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
