package com.bcxin.sp.work.entity.domain.activity.isr;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动，情报研判
 */
@Data
@TableName("sp_activity_isr")
public class ActivityIsr extends Model<ActivityIsr> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityIsrId;

	/**
	 * 活动id
	 */
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityId;

	/**
	 * 情报来源
	 */
	private String source;

	/**
	 * 情报类型
	 */
	private String isrType;

	/**
	 * 情报条目
	 */
	private String isrCount;

	/**
	 * 情报信息
	 */
	private String content;

	/**
	 * 情报时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date isrDate;

	/**
	 * 公安机关机构代码
	 */
	private String policeOrgCode;

	/**
	 * 入库时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.activityIsrId;
	}
}
