package com.bcxin.sp.work.entity.domain.activity.isr;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动，警情数据情报
 *
 * @author wangjianjun
 */
@Data
@TableName("sp_activity_police_isr")
public class ActivityPoliceIsr extends Model<ActivityPoliceIsr> {

    private static final long serialVersionUID = 7064937058904767154L;

    @TableId(type = IdType.INPUT)
    @JsonSerialize(using = ToStringSerializer.class)
    private Long activityPoliceIsrId;

    /**
     * 活动id
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long activityId;

    /**
     * 警情名称
     */
    private String isrName;

    /**
     * 警情级别
     */
    private String isrLevel;

    /**
     * 案事件发生开始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date caseDate;

    /**
     * 治安警情代码
     */
    private String isrCode;

    /**
     * 涉案场所类别
     */
    private String isrAddressType;

    /**
     * 涉案场所名称
     */
    private String isrAddress;

    /**
     * 地址名称
     */
    private String address;

    /**
     * 地球经度	作为GIS打点数据
     */
    private String longitude;

    /**
     * 地球维度	作为GIS打点数据
     */
    private String latitude;

    /**
     * 警情标识
     */
    private String isrMark;

    /**
     * 案由
     */
    private String cause;

    /**
     * 备注
     */
    private String comments;

    /**
     * 公安机关机构代码
     */
    private String policeOrgCode;

    /**
     * 报警人姓名
     */
    private String alarmName;

    /**
     * 报警人联系电话
     */
    private String alarmMobile;

    /**
     * 报警人报警时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date alarmDate;

    /**
     * 处理人姓名
     */
    private String handleName;

    /**
     * 处理人接警时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date handleReceiveDate;

    /**
     * 处理人到达时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date handleArriveDate;

    /**
     * 处理时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date handleDate;

    /**
     * 警情处理结果
     */
    private String process;

    /**
     * 备注
     */
    private String handleRemark;

    /**
     * 处理图片
     */
    private String processImage;

    /**
     * 警情视频信息
     */
    private String video;

    /**
     * 视频设备编码
     */
    private String videoDeviceCode;

    /**
     * 视频文件格式代码
     */
    private String videoFormat;

    /**
     * 视频开始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private String videoStartDate;

    /**
     * 视频结束时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private String videoEndDate;

    /**
     * 音频设备编码
     */
    private String audioDeviceCode;

    /**
     * 音频编码格式代码
     */
    private String audioFormat;

    /**
     * 音频开始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date audioStartDate;

    /**
     * 音频结束时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date audioEndDate;

    /**
     * 嫌疑人标识
     */
    private String suspect;

    /**
     * 警情数据来源
     */
    private String source;

    /**
     * 数据来源行政区划代码
     */
    private String sourceAreaCode;

    /**
     * 入库时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createOn;


    @Override
    protected Serializable pkVal() {
        return this.activityPoliceIsrId;
    }
}
