package com.bcxin.sp.work.entity.domain.activity.monitor;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动视频数据
 */
@Data
@TableName("sp_activity_camera_total")
public class ActivityCameraTotal extends Model<ActivityCameraTotal> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 活动id
     */
    private Long activityId;

    /**
     * 点位id
     */
    private Long deviceCameraId;

    /**
     * 进入数量
     */
    private Integer inCount = 0;

    /**
     * 离开数量
     */
    private Integer outCount = 0;

    /**
     * 人群进入总数
     */
    private Integer inCountTotal = 0;

    /**
     * 人群离开总数
     */
    private Integer outCountTotal = 0;

    /**
     * 事件类型
     */
    private String eventType;

    /**
     * 事件总数
     */
    private Integer eventCount = 0;

    /**
     * 当日峰值
     */
    private Integer todayPeak = 0;

    /**
     * 待入场人数
     */
    private Integer planPersonCount = 0;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime = new Date();

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
