package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动人员，参会人员
 */
@Data
@TableName("sp_activity_person")
public class ActivityPerson extends Model<ActivityPerson> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityPersonId;

	/**
	 * 活动id
	 */
	private Long activityId;

	/**
	 * 人员id
	 */
	private Long personId;

	/**
	 * 人员类别
	 */
	private String personType;

	/**
	 * 是否会务人员
	 * 不是，是
	 */
	private String isConferencePerson ;

	/**
	 * 会务人员类型
	 * 主持人
	 */
	private String conferenceType;

	/**
	 * 会务人员证编号
	 */
	private String conferenceNo;

	/**
	 * 是否是观众
	 * 否，是
	 */
	private String isCrowd;

	/**
	 * 票务类型
	 */
	private String ticketType;

	/**
	 * 票务编号
	 */
	private String ticketNo;

	/**
	 * 座位号
	 */
	private String siteNo;

	/**
	 * 购票日期
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date buyTicketDate;

	/**
	 * 是否入场
	 */
	private String isEntry;

	/**
	 * 入场时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date entryDate;

	/**
	 * 采集时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date addTime;

	/**
	 * 信息入库时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;

	/**
	 * 人脸识别状态
	 */
	private String faceStatus;

	/**
	 * 是否外宾
	 */
	private String isForeign;

	/**
	 * 接待级别
	 */
	private String receiveLevel;


	@Override
	protected Serializable pkVal() {
		return this.activityPersonId;
	}
}
