package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 监控人员出行数据
 * 公安检查站
 * @author
 */
@Data
@TableName("sp_activity_person_Monitor_Check_track")
public class ActivityPersonMonitorCheckTrack extends Model<ActivityPersonMonitorCheckTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonMonitorCheckTrack;

	/**
	 * 人员id
	 */
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonId;

	/**
     * 信息类型
	 */
	private String trackType;

	/**
	 * 检查站编码
	 */
	private String stationNo;

	/**
	 * 检查站位置
	 */
	private String station;

	/**
	 * 查验时间
	 */
	private String checkDate;

	/**
	 * 出入类型
	 */
	private String checkType;

	/**
	 * 采集时间
	 */
	private String collectDate;

	/**
	 * 信息入库时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.activityPersonId;
	}
}
