package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 监控人员出行数据
 * 人脸识别
 */
@Data
@TableName("sp_activity_person_Monitor_face_track")
public class ActivityPersonMonitorFaceTrack extends Model<ActivityPersonMonitorFaceTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonMonitorFaceTrackId;

	/**
	 * 人员id
	 */
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonId;

	/**
     * 信息类型
	 */
	private String trackType;

	/**
	 * 设备id
	 */
	@JsonSerialize(using= ToStringSerializer.class)
	private Long deviceCameraId;

	/**
	 * 抓拍的照片
	 */
	private String photo;

	/**
	 * 抓拍时间
	 */
	private String captureDate;

	/**
	 * 采集时间
	 */
	private String collectDate;

	/**
	 * 入库时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.activityPersonMonitorFaceTrackId;
	}

	/**
	 * 非数据库字段
	 */
	/**
	 * 视频设备编码	设备编号
	 */
	private String serialNumber;

	/**
	 * 设备名称	设备的详细登入名称
	 */
	private String fullName;

	/**
	 * 监视方向
	 */
	private String monitorDirection;

	/**
	 * 安装地点地址名称
	 */
	private String installAddress;

	/**
	 * 设备类型	设备类型说明
	 */
	private String deviceCameraType;
}
