package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动人员，工作人员
 */
@Data
@TableName("sp_activity_person_staff")
public class ActivityPersonStaff extends Model<ActivityPersonStaff> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityPersonStaffId;

	/**
	 * 活动id
	 */
	private Long activityId;

	/**
	 * 人员id
	 */
	private Long personId;

	/**
	 * 证件类型
	 */
	private String cardType;

	/**
	 * 证件编号
	 */
	private String cardNo;

	/**
     * 是否入场
	 */
	private String isEntry;

    /**
	 * 入场时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm")
	private Date entryDate;

    /**
	 * 制证时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm")
	private Date accreditationDate;


	@Override
	protected Serializable pkVal() {
		return this.activityPersonStaffId;
	}
}
