package com.bcxin.sp.work.entity.domain.activity.plan;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动预案
 */
@Data
@TableName("sp_activity_plan")
public class ActivityPlan extends Model<ActivityPlan> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityPlanId;

	/**
	 * 活动id
	 */
	private Long activityId;

	/**
	 * 预案名称
	 */
	private String planName;

	/**
	 * 预案类型
	 */
	private String planType;

	/**
	 * 活动级别
	 */
	private String activityLevel;

	/**
	 * 安保级别
	 */
	private String securityLevel;

	/**
	 * 涉密级别
	 */
	private String classifiedLevel;

	/**
	 * 总指挥
	 */
	private String commander;

	/**
	 * 副总指挥
	 */
	private String assistantCommander;

	/**
	 * 参与部门
	 */
	private String departmentInvolved;

	/**
	 * 总面积
	 */
	private String grossArea;

	/**
	 * 参与人数
	 */
	private String involvedNum;

	/**
	 * 附件地址
	 */
	private String fileUrl;

	/**
	 * 预案描述
	 */
	private String planDes;

	/**
	 * 开始时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JSONField(format="yyyy-MM-dd HH:mm")
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date startTime;

	/**
	 * 添加时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date addTime;

	/**
	 * 修改时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date updateTime;

	private String updater = "system";

	@Override
	protected Serializable pkVal() {
		return this.activityPlanId;
	}
}
