package com.bcxin.sp.work.entity.domain.activity.security;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 安保任务（保安和警力共用）
 */
@Data
@TableName("sp_activity_security_task")
public class SecurityTask extends Model<SecurityTask> {

	private static final long serialVersionUID = 7064937058904767154L;


	@JsonSerialize(using=ToStringSerializer.class)
	@TableId(type = IdType.INPUT)
	private Long securityTaskId;

	private Long activityId;
	/**
	 * 任务编号
	 */
	private String serialNumber;
	/**
	 * 任务名称
	 */
	private String fullName;
	/**
	 * 任务类型
	 * 1、巡逻
	 */
	private String securityTaskType;
	/**
	 * 执行单位类型
	 * （1、安保公司，2、公安机关，）
	 */
	private String orgType;
	/**
	 * 任务开始时间
	 */
	private String startDate;
	/**
	 * 任务结束时间
	 */
	private String endDate;

	/**
	 * 任务内容
	 */
	private String content;
	/**
	 * 任务处置方案文件
	 */
	private String disposeUrl;

	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.securityTaskId;
	}
}
