package com.bcxin.sp.work.entity.domain.activity.security;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 安保任务-保安-关联表（保安）
 */
@Data
@TableName("sp_activity_security_task_person")
public class SecurityTaskPerson extends Model<SecurityTaskPerson> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.AUTO)
	private Long securityTaskPersonId;

	/**
	 * 安保任务id
	 */
	private Long securityTaskId;

	/**
	 * 保安人员
	 */
	private Long securityPersonId;

	/**
	 * 人员巡逻类别
	 * 1，巡逻
	 */
	private String taskPersonType;

	/**
	 * 是否工作组负责人标识
	 */
	private String isLeader;

	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.securityTaskPersonId;
	}
}
