package com.bcxin.sp.work.entity.domain.activity.session;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <b> 场次信息 </b>
 * @author ZXF
 * @create 2025/01/14 0014 13:23
 * @version
 * @注意事项 </b>
 */
@Data
@TableName("SP_ACTIVITY_SESSION")
public class ActivitySession extends Model<ActivitySession> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime = new Date();
    private Long activityId; //活动
    private int isImprove = 0; //是否完善

    /**
     * 开始时间
     */
    private String startDate;

    /**
     * 结束时间
     */
    private String endDate;

    /**
     * 观众数量
     */
    private Integer audienceNumber;
    /**
     * 警力数量
     */
    private Integer forcesNumber;
    /**
     * 保安数量
     */
    private Integer securityNumber;
    /**
     * 志愿者数量
     */
    private Integer volunteerNumber;
    /**
     * 负责人名字
     */
    private String headName;

    /**
     * 负责人职务
     */
    private String headPosition;

    /**
     * 负责人电话
     */
    private String headPhone;

    /**
     * 负责人单位
     */
    private String headOrg;
    /**
     * 指挥人名字
     */
    private String leaderName;

    /**
     * 指挥人职务
     */
    private String leaderPosition;

    /**
     * 指挥人电话
     */
    private String leaderPhone;

    /**
     * 指挥人单位
     */
    private String leaderOrg;
    /**
     * 联系人名字
     */
    private String contactName;

    /**
     * 联系人职务
     */
    private String contactPosition;

    /**
     * 联系电话
     */
    private String contactPhone;

    /**
     * 联系人单位
     */
    private String contactOrg;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }


}
