package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 低慢小，飞行器信息
 */
@Data
@TableName("base_Aircraft")
public class Aircraft extends Model<Aircraft> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using = ToStringSerializer.class)
	private Long aircraftId;

	/**
	 * 设备名称
	 */
	private String deviceName;

	/**
	 * 设备序列号
	 */
	private String deviceNo;

	/**
	 * 飞行器类型
	 */
	private String aircraftType;

	/**
	 * 品牌型号
	 */
	private String brandModel;

	/**
	 * 厂商名称
	 */
	private String brandFactory;

	/**
	 * 物品购置日期
	 */
	private String buyDate;

	/**
	 * 单位名称
	 */
	private String org;

	/**
	 * 组织机构代码
	 */
	private String orgCode;

	/**
	 * 姓名
	 */
	private String fullName;

	/**
	 * 公民身份号码
	 */
	private String idCardNo;

	/**
	 * 地球经度	作为GIS打点数据
	 */
	private String longitude;

	/**
	 * 地球维度	作为GIS打点数据
	 */
	private String latitude;

	/**
	 * 飞行高度
	 */
	private String flyHeight;

	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.aircraftId;
	}
}
