package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 基础车辆信息
 */
@Data
@TableName("base_car")
public class Car extends Model<Car> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long carId;

	/**
	 * 机动车号牌
	 */
	private String vehicleNo;

	/**
	 * 车辆型号
	 */
	private String carModel;

	/**
	 * 机动车车身颜色
	 */
	private String carColor;

	/**
	 * 中文品牌名称
	 */
	private String brandCN;

	/**
	 * 英文品牌名称
	 */
	private String brandEN;

	/**
	 * 车辆种类
	 */
	private String carCategory;

	/**
	 * 车辆类型
	 */
	private String carType;

	/**
	 * 车辆用途
	 */
	private String carUse;

	/**
	 * 负责人
	 */
	private String carCharge;

	/**
	 * 车辆司机
	 */
	private String carDriver;


	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.carId;
	}
}
