package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 基础信息，停车场
 */
@Data
@TableName("base_park")
public class Park extends Model<Park> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long parkId;

	/**
	 * 编号
	 */
	private String parkNo;

	/**
	 * 停车场名称
	 */
	private String parkName;

	/**
	 * 停车场类型
	 */
	private String parkType;

	/**
	 * 停车场位置
	 */
	private String packAddress;

	/**
	 * 入口数量
	 */
	private String entryCount;

	/**
	 * 出口数量
	 */
	private String exitCount;

	/**
	 * 地址经度	作为GIS打点数据
	 */
	private String longitude;

	/**
	 * 地址纬度	作为GIS打点数据
	 */
	private String latitude;

	/**
	 * 停车位数量
	 */
	private String total;

	/**
	 * 管理单位
	 */
	private String manageOrg;

	/**
	 * 管理负责人
	 */
	private String manageName;

	/**
	 * 管理负责人手机
	 */
	private String manageMobile;

	/**
	 * 来源
	 */
	private String source;

	/**
	 * 数据状态
	 */
	private String dataStatus;

	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.parkId;
	}
}
