package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 警车基本信息
 */
@Data
@TableName("base_police_car")
public class PoliceCar extends Model<PoliceCar> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long policeCarId;

	/**
	 * 巡逻车编号
	 */
	private String carNo;

	/**
	 * 机动车号牌
	 */
	private String vehicleNo;

	/**
	 * 车辆型号
	 */
	private String carModel;

	/**
	 * 车辆种类
	 */
	private String carType;

	/**
	 * 行政区划代码
	 */
	private String areaCode;

	/**
	 * 公安机关机构代码
	 */
	private String policeAreaCode;

	/**
	 * 公安机关名称
	 */
	private String policeOrg;

	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.policeCarId;
	}
}
