package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;

/**
 * 场馆
 */
@Data
@TableName("base_venue")
public class Venue extends Model<Venue> {

	private static final long serialVersionUID = -7088672083348697781L;

	@TableId(type = IdType.AUTO)
	private Long id;

	/**
	 * 场馆名称
	 */
	private String fullName;

	/**
	 * 场馆地址
	 */
	private String address;

	/**
	 * 建成日期
	 */
	private String buildDate;

	/**
	 * 支持的活动
	 * （100001,100002）
	 */
	private transient String support;

	/**
	 * 场馆容量上限
	 */
	private String capacityMax;


	@Override
	protected Serializable pkVal() {
		return this.id;
	}
}
