package com.bcxin.sp.work.entity.domain.log;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 文件同步标示
 */
@Data
@TableName("log_filesync")
public class FileSyncLog extends Model<FileSyncLog> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.AUTO)
	private Long id;

	/**
	 * 同步的文件名称
	 */
	private String fileName;

	/**
	 * 是否已读状态，默认为未读
	 */
	private String markRead = "0";

	/**
	 * 同步状态，默认为未同步
	 */
	private String sync = "0";

	/**
	 * 同步异常信息
	 */
	private String exception;

	/**
	 * 同步时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JSONField(format="yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date addTime = new Date();



	@Override
	protected Serializable pkVal() {
		return this.id;
	}
}
