package com.bcxin.sp.work.entity.domain.user;

import lombok.Data;

/**
 * 登录用户明细(非db表)
 * 例：浙江登录用户，记录用户的终端信息，需要回调日志审计平台
 */
@Data
public class LoginUserDetail {

    private static final long serialVersionUID = -3493875375229017179L;

    /**
     * 用户标识
     * 采用数字证书进行用户身份验证的应用系统，填写用户公民身份号码。
     * 未采用数字证书进行用户身份验证的应用系统/资源库，则填写警号
     */
    private String userId;

    /**
     * 单位名称
     * 用户所属单位的公安机关机构名称，采用GA/T 543 DE00065 单位名称（可从警员PKI证书认证反馈信息中获取）
     */
    private String organization;

    /**
     * 用户名
     * 采用GA/T 543 DE00002 姓名（可从警员PKI证书认证反馈信息中获取）
     */
    private String userName;

    /**
     * 终端标识
     * 用户操作时所使用的信息处理终端的唯一标识；对于直接接入公安网使用的信息处理终端，填写其网络IP地址，如：10.2.64.71；移动警务终端通过网络安全边界接入设备接入公安网的，填写该终端的硬件序列号
     */
    private String terminalID;

    //  Operate_Type
    //	Operate_Time
    //	Operate_Condition
    //	Operate_Result

}
