package com.bcxin.sp.work.entity.domain.user;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
@TableName("sp_se_user")
public class User extends Model<User> {

    private static final long serialVersionUID = -3493875375229017179L;
    @TableId(type = IdType.AUTO)
    private Long id;
    private Date addTime = new Date();
    private Date updateTime = new Date();
    private String updater = "system";

    private String username;
    private String password;
    private String realName;
    private String pic;
    private String phone;
    /**
     * 是管理员还是审批人员
     */
    private String role;

    /**
     * 审批角色
     */
    private String workRole;

    private String province;
    private String city;
    private String area;
    /**
     * 是否对一次登录，0否 1 是
     */
    private String firstLogin;
    private boolean active = true;
    private int regionLevel = 3;

    /**
     * 警号
     */
    private String policeNumber;
    /**
     * 部门
     */
    private String depart;
    /**
     * 机构code
     */
    private String organCode;

    @TableField(exist = false)
    private String provincename;
    @TableField(exist = false)
    private String cityname;
    @TableField(exist = false)
    private String areaname;
    @TableField(exist = false)
    private String workrolename;
    @TableField(exist = false)
    private String defaultProvince;
    @TableField(exist = false)
    private String defaultCity;
    //标记token登录日期
    @TableField(exist = false)
    private String loginDay;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 密码修改时间
     */
    private Date lastPasswordDate;

}
