package com.bcxin.sp.work.entity.dto;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * <b> 活动对象 </b>
 * @author ZXF
 * @create 2023/11/13 0013 16:23
 * @version
 * @注意事项 </b>
 */
@Data
public class FileInfoAnbaoDto implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 附件ID，对应表字段为：SYS_FILE_INFO.FILE_ID
     */
    private String fileId;

    /**
     * 附件名称，对应表字段为：SYS_FILE_INFO.FILE_NAME
     */
    private String fileName;

    /**
     * 附件类型，对应表字段为：SYS_FILE_INFO.FILE_TYPE
     */
    private String fileType;

    /**
     * 附件地址，对应表字段为：SYS_FILE_INFO.FILE_DIR
     */
    private String fileDir;

    /**
     * 附件大小，对应表字段为：SYS_FILE_INFO.FILE_SIZE
     */
    private BigDecimal fileSize;

    /**
     * 附件请求地址
     */
    private String fileUrl;

    /**
     * 关联ID，对应表字段为：SYS_FILE_INFO.REL_ID
     */
    private String relId;

    /**
     * 附件编号，对应表字段为：SYS_FILE_INFO.FILE_NO
     */
    private String fileNo;

    /**
     * 附件排序，对应表字段为：SYS_FILE_INFO.ORDER_NO
     */
    private Integer orderNo;

    /**
     * 附件主题，见字典表：安全管理附件主题AQGL_FILE_TITLE，对应表字段为：SYS_FILE_INFO.FILE_TITLE
     */
    private String fileTitle;
    private String createTime;
}
