package com.bcxin.sp.work.entity.dto;

import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * 高级搜索类
 *
 * @author Ethan_Huang
 */
@Data
public class SearchDto<T> {

    private Integer regionLevel;
    private String province = "";
    private String city = "";
    private String area = "";
    private String approveStatus;
    private String approveStatusSummary;
    private String sProvince;
    private String sCity;
    private String sArea;
    private Boolean gov;
    private String addTime;
    private String startDate;
    private String endDate;
    private String keywords;
    private String userName;
    private String realName;
    private String role;
    private String sRole;
    private String sWorkRole;
    private String readStatus;
    private String areaCode;
    private String activityChannel;
    private Integer active;
    private Long userId;
    private Integer areaCodeLevel;

    private Integer iDisplayStart;
    private Integer iDisplayLength;
    private long iTotalRecords;
    private long iTotalDisplayRecords;

    private List<T> data = new ArrayList<T>();

    /**
     * 活动类型
     */
    private String typeCode;
    /**
     * 同步标记
     */
    private String sync;
    /**
     * 审批时间-开始时间
     */
    private String addApproveDate;
    /**
     * 审批时间-结束时间
     */
    private String endApproveDate;
    /**
     * 报批时间-开始时间
     */
    private String addTimeStartDate;
    /**
     * 报批时间-结束时间
     */
    private String addTimeEndDate;

    /**
     * 活动结束日期-开始时间
     */
    private String finishStartDate;
    /**
     * 活动结束日期-结束时间
     */
    private String finishEndDate;

    /**
     * 数据源：值为summary则是“活动汇总”弹窗进行查询，取消“isGov”条件过滤
     */
    private String dataSource;

    private boolean isHistorySearch;
    private String isQkPerson;
    private String isZtPerson;
    private String isJdPerson;
    private String isFfPerson;
    private String isSkPerson;
    private String isXdPerson;
    private String isJsbr;
    private String personType;
    private String isConferencePerson;
    private String isCrowd;
    private String isForeign;
    private String isBack;
    private String categoryName;
    private String monitorStatus;
    private String isEntry;
    private String carType;
    private String parkType;
    private String sex;
    private String taskPersonType;
    private String policeType;
    private String isLeader;
    private String startDate2;
    private String endDate2;
    private String carCategory;
    /**
     * 活动编码
     */
    private String activityNo;
    /**
     * 安保任务id
     */
    private String taskId;
    /**
     * 参会人员id
     */
    private String activityPersonId;
    private String activityCarId;
    /**
     * 设备类型
     */
    private String deviceCameraType;
    /**
     * 预案类型类型
     */
    private String emergencyPlanType;
    /**
     * 任务类型
     */
    private String securityTaskType;
    /**
     * 机构类型
     */
    private String orgType;
    /**
     * 任务状态
     */
    private String taskStatus;

    /*   预案参数   */
    private String activityId;
    private String planType;
    private String activityLevel;
    private String securityLevel;
    private String classifiedLevel;

    /*   承办者参数   */
    private String phone;
    private String organizationCode;
    private String contractorType;
    private String assessmentType;

    public long getiTotalRecords() {
        return iTotalRecords;
    }

    public long getiTotalDisplayRecords() {
        return iTotalDisplayRecords;
    }

}
