package com.bcxin.sp.work.entity.dto.zj;


import cn.hutool.core.date.DateUtil;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.activity.session.ActivitySession;
import com.bcxin.sp.work.entity.domain.user.User;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Data
public class EventDataDTO {

    private String actionname;
    private String actionsite;
    private String introduce;
    private List<String> labels;
    private String points;
    private String reportcode;
    private String reportcompany;
    private String reportphone;
    private String reportusername;
    private String reprotname;
    private String type;
    private String undertake;
    private String undertakeregaddr;
    private double x;
    private double y;
    private List<PlaceDetails> places;

    @Data
    public static class PlaceDetails {
        private int actionid;
        private int id;
        //联系人
        private String connectcompany;
        private String connectjob;
        private String connectname;
        private String connectphone;
        private String createtime;
        private String starttime;
        private String endtime;
        //负责人
        private String majorcompany;
        private String majorjob;
        private String majormame;
        private String majorphone;
        //指挥人
        private String ordercompany;
        private String orderjob;
        private String ordername;
        private String orderphone;
        private int policenum;
        private int securitynum;
        private int viewernum;
        private int volunteernum;

        public PlaceDetails(int actionid, int id, String connectcompany, String connectjob, String connectname, String connectphone,
                            String createtime, String starttime, String endtime, String majorcompany, String majorjob, String majormame,
                            String majorphone, String ordercompany, String orderjob, String ordername, String orderphone,
                            int policenum, int securitynum, int viewernum, int volunteernum) {
            this.actionid = actionid;
            this.id = id;
            this.connectcompany = connectcompany;
            this.connectjob = connectjob;
            this.connectname = connectname;
            this.connectphone = connectphone;
            this.createtime = createtime;
            this.starttime = starttime;
            this.endtime = endtime;
            this.majorcompany = majorcompany;
            this.majorjob = majorjob;
            this.majormame = majormame;
            this.majorphone = majorphone;
            this.ordercompany = ordercompany;
            this.orderjob = orderjob;
            this.ordername = ordername;
            this.orderphone = orderphone;
            this.policenum = policenum;
            this.securitynum = securitynum;
            this.viewernum = viewernum;
            this.volunteernum = volunteernum;
        }
    }


    public EventDataDTO(String actionname, String actionsite, String introduce, List<String> labels, String points,
                        String reportcode, String reportcompany, String reportphone, String reportusername, String reprotname, String type,
                        String undertake, String undertakeregaddr, double x, double y, List<PlaceDetails> places) {
        this.actionname = actionname;
        this.actionsite = actionsite;
        this.introduce = introduce;
        this.labels = labels;
        this.points = points;
        this.reportcode = reportcode;
        this.reportcompany = reportcompany;
        this.reportphone = reportphone;
        this.reportusername = reportusername;
        this.reprotname = reprotname;
        this.type = type;
        this.undertake = undertake;
        this.undertakeregaddr = undertakeregaddr;
        this.x = x;
        this.y = y;
        this.places = places;
    }

    public static EventDataDTO create(User user, Activity activity, List<ActivitySession> list) {
        List<PlaceDetails> places = new ArrayList<>();
        PlaceDetails placeDetails;
        for (ActivitySession activitySession : list){
            placeDetails = new PlaceDetails(Integer.parseInt(activity.getId()+""),Integer.parseInt(activitySession.getId()+""),activitySession.getContactOrg(),activitySession.getContactPosition(),activitySession.getContactName(),activitySession.getContactPhone()
                    , DateUtil.formatDateTime(new Date()),activitySession.getStartDate()+":00",activitySession.getEndDate()+":00"
                    ,activitySession.getHeadOrg(),activitySession.getHeadPosition(),activitySession.getHeadName(),activitySession.getHeadPhone()
                    ,activitySession.getLeaderOrg(),activitySession.getLeaderPosition(),activitySession.getLeaderName(),activitySession.getLeaderPhone()
                    ,activitySession.getForcesNumber(),activitySession.getSecurityNumber(),activitySession.getAudienceNumber(),activitySession.getVolunteerNumber()
                    );
            places.add(placeDetails);
        }
        List<String> labels = new ArrayList<>();
        labels.add("1");
        if("100001".equals(activity.getTypeCode())){
            labels.add("5");
            if(activity.getIntroduce().contains("水")){
                labels.add("6");
            }else if(activity.getIntroduce().contains("场馆")){
                labels.add("7");
            }else{
                labels.add("8");
            }
        }else if("100002".equals(activity.getTypeCode())){
            if(activity.getIntroduce().contains("演唱会")){
                labels.add("64");
            }else{
                labels.add("14");
                if(activity.getIntroduce().contains("场馆")){
                    labels.add("37");
                }else if(activity.getIntroduce().contains("户外")){
                    labels.add("38");
                }else{
                    labels.add("37");
                }
            }
        }else if("100003".equals(activity.getTypeCode())){
            labels.add("12");
            labels.add("13");
        }else if("100004".equals(activity.getTypeCode())){
            labels.add("17");
            if(activity.getIntroduce().contains("游园")){
                labels.add("18");
            }else if(activity.getIntroduce().contains("庙会")){
                labels.add("19");
            }else if(activity.getIntroduce().contains("灯会")){
                labels.add("20");
            }else if(activity.getIntroduce().contains("花会")){
                labels.add("20");
            }else{
                labels.add("18");
            }
        }else if("100005".equals(activity.getTypeCode())){
            if(activity.getIntroduce().contains("彩票")){
                labels.add("22");
            }else{
                labels.add("4");
            }
        }else if("100006".equals(activity.getTypeCode())){
            labels.add("23");
        }else if("100007".equals(activity.getTypeCode())){
            labels.add("23");
        }
        Double x = Double.valueOf(0);
        Double y = Double.valueOf(0);
        if(StringUtils.isNotEmpty(activity.getCoordinate())){
            String[] arr = activity.getCoordinate().split(",");
            x = Double.parseDouble(arr[0]);
            y = Double.parseDouble(arr[1]);
        }
        return new EventDataDTO(activity.getFullName(), activity.getAddress(), activity.getIntroduce(), labels, activity.getCoordinate()
                ,user.getOrganCode(),user.getDepart(), user.getPhone(), user.getUsername(), user.getRealName(), "1", activity.getSponsor(), activity.getSponsorAddress()
                , x, y, places);
    }
}
