package com.bcxin.sp.work.service.activity.approve;

import com.bcxin.sp.work.dao.activity.approve.ApproveRoleMapper;
import com.bcxin.sp.work.entity.domain.activity.approve.ApproveRole;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class ApproveRoleService {
    @Autowired
    private ApproveRoleMapper approveRoleDao;

    public void save(ApproveRole approveRole) {
        approveRoleDao.insert(approveRole);
    }

    public void update(ApproveRole approveRole) {
        approveRoleDao.updateById(approveRole);
    }

    public void delete(ApproveRole approveRole) {
        approveRoleDao.deleteById(approveRole);
    }

    public ApproveRole findById(long id) {
        return approveRoleDao.findById(id);
    }

    public List<ApproveRole> findByRegion(String province, String city, String area) {
        return approveRoleDao.findByRegion(province, city, area);
    }
}
