package com.bcxin.sp.work.service.activity.car;

import com.bcxin.sp.work.dao.activity.car.CarMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.traffic.ActivityTraffic;
import com.bcxin.sp.work.entity.domain.base.PoliceCar;
import com.bcxin.sp.work.entity.dto.ActivityCarTrackDTO;
import com.bcxin.sp.work.entity.dto.CarDTO;
import com.bcxin.sp.work.entity.dto.ParkDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
@Transactional
public class CarService {

    @Resource
    private CarMapper carMapper;


    public PageResult findZdclListData(SearchDto<CarDTO> dto) throws Exception {
        List<CarDTO> list = carMapper.findZdclListData(dto);
        Long total = carMapper.findZdclListDataCnt(dto);
        return new PageResult(list,total);
    }

    public PageResult findZdclwzListData(SearchDto<ActivityCarTrackDTO> dto) throws Exception {
        List<ActivityCarTrackDTO> list = carMapper.findZdclwzListData(dto);
        Long total = carMapper.findZdclwzListDataCnt(dto);
        return new PageResult(list,total);
    }

    public PageResult findJcjbsjListData(SearchDto<PoliceCar> pc) throws Exception {
        List<PoliceCar> list = carMapper.findJcjbsjListData(pc);
        Long total = carMapper.findJcjbsjListDataCnt(pc);
        return new PageResult(list,total);
    }

    public PageResult findTccListData(SearchDto<ParkDTO> dto) throws Exception {
        List<ParkDTO> list = carMapper.findTccListData(dto);
        Long total = carMapper.findTccListDataCnt(dto);
        return new PageResult(list,total);
    }

    public PageResult findJtlkListData(SearchDto<ActivityTraffic> at) throws Exception {
        List<ActivityTraffic> list = carMapper.findJtlkListData(at);
        Long total = carMapper.findJtlkListDataCnt(at);
        return new PageResult(list,total);
    }

}
