package com.bcxin.sp.work.service.activity.extend;

import com.bcxin.sp.work.dao.activity.extend.ActivityEmergencyPlanMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityEmergencyPlan;
import com.bcxin.sp.work.entity.dto.SearchDto;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class ActivityEmergencyPlanService {

    @Resource
    private ActivityEmergencyPlanMapper activityEmergencyPlanMapper;

    /**
     * <b> 根据活动查询应急预案 </b>
     * @author ZXF
     * @create 2020/02/28 0028 15:03
     * @version
     * @注意事项 </b>
     */
    public List<Map> findActivityEmergencyPlanListByActivityId(long activityId) {
        return activityEmergencyPlanMapper.findActivityEmergencyPlanListByActivityId(activityId);
    }

    public PageResult findYjclyaListData(SearchDto<ActivityEmergencyPlan> dto) throws Exception {
        List<ActivityEmergencyPlan> list = activityEmergencyPlanMapper.findYjclyaListData(dto);
        Long total = activityEmergencyPlanMapper.findYjclyaListDataCnt(dto);
        return new PageResult(list,total);
    }
}
