package com.bcxin.sp.work.service.activity.person;

import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.activity.person.ActivityPersonMapper;
import com.bcxin.sp.work.dao.activity.person.zdrysmz.*;
import com.bcxin.sp.work.dao.activity.temp.TempActivityInfoMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.person.*;
import com.bcxin.sp.work.entity.domain.activity.temp.TempActivityInfo;
import com.bcxin.sp.work.entity.dto.ActivityPersonDTO;
import com.bcxin.sp.work.entity.dto.PersonMonitorFaceDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.accident.ActivityPersonAirSearchDTO;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class ActivityPersonService {

    @Resource
    private ActivityPersonMapper activityPersonMapper;
    @Resource
    private ActivityPersonMonitorAirTrackMapper activityPersonMonitorAirTrackMapper;
    @Resource
    private ActivityPersonMonitorBarTrackMapper activityPersonMonitorBarTrackMapper;
    @Resource
    private ActivityPersonMonitorCheckTrackMapper activityPersonMonitorCheckTrackMapper;
    @Resource
    private ActivityPersonMonitorFaceTrackMapper activityPersonMonitorFaceTrackMapper;
    @Resource
    private ActivityPersonMonitorHotelTrackMapper activityPersonMonitorHotelTrackMapper;
    @Resource
    private ActivityPersonMonitorRoadTrackMapper activityPersonMonitorRoadTrackMapper;
    @Resource
    private ActivityPersonMonitorShipTrackMapper activityPersonMonitorShipTrackMapper;
    @Resource
    private ActivityPersonMonitorTrainTrackMapper activityPersonMonitorTrainTrackMapper;
    @Resource
    private TempActivityInfoMapper tempActivityInfoMapper;

    public PageResult findRybsListData(SearchDto<ActivityPersonDTO> dto) throws Exception {
        List<ActivityPersonDTO> list = activityPersonMapper.findRybsListData(dto);
        Long total = activityPersonMapper.findRybsListDataCnt(dto);
        return new PageResult(list, total);
    }

    public PageResult findChryListData(SearchDto<ActivityPersonDTO> dto) throws Exception {
        List<ActivityPersonDTO> list = activityPersonMapper.findChryListData(dto);
        Long total = activityPersonMapper.findChryListDataCnt(dto);
        return new PageResult(list, total);
    }

    public PageResult findZdryListData(SearchDto<ActivityPersonDTO> dto) throws Exception {
        List<ActivityPersonDTO> list = activityPersonMapper.findZdryListData(dto);
        Long total = activityPersonMapper.findZdryListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 重点人员详情
     *
     * @param id
     * @return
     * @throws Exception
     * @author wangjianjun
     * @date 2020/5/15
     */
    public Map<String, Object> findZdryDetailData(Long id) throws Exception {
        return activityPersonMapper.findZdryDetailData(id);
    }

    public PageResult findDtxxListData(SearchDto<PersonMonitorFaceDTO> dto) throws Exception {
        List<PersonMonitorFaceDTO> list = activityPersonMapper.findDtxxListData(dto);
        Long total = activityPersonMapper.findDtxxListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 列表
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorAirTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorAirTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorAirTrack> list = activityPersonMonitorAirTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-网吧
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorBarTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorBarTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorBarTrack> list = activityPersonMonitorBarTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-公安检查站
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorCheckTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorCheckTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorCheckTrack> list = activityPersonMonitorCheckTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-人脸识别
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorFaceTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorFaceTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorFaceTrack> list = activityPersonMonitorFaceTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-旅馆住宿
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorHotelTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorHotelTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorHotelTrack> list = activityPersonMonitorHotelTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-公路
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorRoadTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorRoadTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorRoadTrack> list = activityPersonMonitorRoadTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-轮船
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorShipTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorShipTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorShipTrack> list = activityPersonMonitorShipTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 列表-铁路
     * @author wangjianjun
     * @date 2020/5/15
     */
    public PageResult findActivityPersonMonitorTrainTrackList(ActivityPersonAirSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPersonMonitorTrainTrack> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<ActivityPersonMonitorTrainTrack> list = activityPersonMonitorTrainTrackMapper.findAllByTrackTypeAndCollectDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    public PageResult findTempActivityInfo(SearchDto searchDTO){
        Page<TempActivityInfo> page = new Page<>(searchDTO.getIDisplayStart() / searchDTO.getIDisplayLength() + 1, searchDTO.getIDisplayLength());
        List<TempActivityInfo> list = tempActivityInfoMapper.findAllByCarCategoryOrSex(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

}
