package com.bcxin.sp.work.service.log;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.toolkit.IdWorker;
import com.bcxin.sp.work.dao.log.AuditLogMapper;
import com.bcxin.sp.work.entity.domain.log.AuditLog;
import com.bcxin.sp.work.entity.domain.log.OperateLog;
import com.bcxin.sp.work.entity.domain.user.LoginUserDetail;
import com.bcxin.sp.work.entity.dto.OperateLogSearchDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class AuditLogService {

    @Autowired
    private com.bcxin.sp.work.service.user.UserService userService;

    @Autowired
    private AuditLogMapper auditLogMapper;

    public void auditLog1(int opType,String opCondition,String opResult,LoginUserDetail userDetail) {
        if (userDetail == null) {
            return;
        }
        AuditLog log = new AuditLog();
        log.setNum_ID(IdWorker.getId()+"");
        log.setOrganization(userDetail.getOrganization());
        log.setTerminal_ID(userDetail.getTerminalID());
        log.setUser_Name(userDetail.getUserName());
        log.setUser_ID(userDetail.getUserId());
        log.setOperate_Type(opType);
        log.setOperate_Time(DateUtil.format(DateUtil.date(), DatePattern.PURE_DATETIME_FORMAT) );
        log.setOperate_Condition(opCondition);
        log.setOperate_Result(opResult);
        auditLogMapper.insert(log);
    }

    public void auditLog(int opType,String opCondition,String opResult) {
        LoginUserDetail userDetail = userService.getCurrentUserDetail();
        if (userDetail == null) {
            return;
        }
        AuditLog log = new AuditLog();
        log.setNum_ID(IdWorker.getId()+"");
        log.setOrganization(userDetail.getOrganization());
        log.setTerminal_ID(userDetail.getTerminalID());
        log.setUser_Name(userDetail.getUserName());
        log.setUser_ID(userDetail.getUserId());
        log.setOperate_Type(opType);
        log.setOperate_Time(DateUtil.format(DateUtil.date(), DatePattern.PURE_DATETIME_FORMAT) );
        log.setOperate_Condition(opCondition);
        log.setOperate_Result(opResult);
        auditLogMapper.insert(log);
    }

    public List<AuditLog> searchLog(OperateLogSearchDTO dto){
        return auditLogMapper.searchLog(dto);
    }

    public long searchLogCount(OperateLogSearchDTO dto){
        return auditLogMapper.searchLogCount(dto);
    }


}
