package com.bcxin.sp.work.service.log;

import com.bcxin.sp.work.dao.log.ExceptionLogMapper;
import com.bcxin.sp.work.dao.log.FileSyncLogMapper;
import com.bcxin.sp.work.entity.domain.log.ExceptionLog;
import com.bcxin.sp.work.entity.domain.log.FileSyncLog;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.util.LongUtil;
import com.bcxin.sp.work.util.StringUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
@Transactional
public class LogService {

    @Resource
    private ExceptionLogMapper exceptionLogMapper;

    @Resource
    private FileSyncLogMapper fileSyncLogMapper;


    public void save(FileSyncLog fileSyncLog) {
        fileSyncLogMapper.insert(fileSyncLog);
    }

    public void logException(String exception) {
        ExceptionLog log = new ExceptionLog();
        log.setAddTime(new Date());
        log.setExceptionInfo(exception);
        exceptionLogMapper.insert(log);
    }

    public void mergeMark(FileSyncLog fileSyncLog) {
        if (fileSyncLog ==null) {
            return;
        }
        if (LongUtil.isEmpty(fileSyncLog.getId())) {
            fileSyncLog.setAddTime(new Date());
            fileSyncLogMapper.insert(fileSyncLog);
        } else {
            fileSyncLogMapper.updateById(fileSyncLog);
        }
    }

    public List<FileSyncLog> findByPage(SearchDto<FileSyncLog> dto) {
        StringBuffer condition = new StringBuffer();
        condition.append(" WHERE 1=1 ");
        if(StringUtil.isNotEmpty(dto.getKeywords())) {
            condition.append(" AND fileName like '%"+dto.getKeywords()+"%' ");
        }
        condition.append(" ORDER BY id DESC");
        condition.append(" limit ");
        condition.append(dto.getIDisplayStart());
        condition.append(",");
        condition.append(dto.getIDisplayLength());
        return fileSyncLogMapper.findByPage(condition.toString());
    }

    public long findCount(SearchDto<FileSyncLog> dto) {
        StringBuffer condition = new StringBuffer();
        condition.append(" WHERE 1=1 ");
        if(StringUtil.isNotEmpty(dto.getKeywords())) {
            condition.append(" AND fileName like '%"+dto.getKeywords()+"%' ");
        }
        return fileSyncLogMapper.findCount(condition.toString());
    }

    public FileSyncLog findRecord(String mark) {
        return fileSyncLogMapper.findRecord(mark);
    }

    /**
     * 查找所有已读但是未同步的的文件记录
     * @return
     */
    public List<FileSyncLog> findNeedSyncRecord() {
        return fileSyncLogMapper.findNeedSyncRecord();
    }


    /**
     * 查找今天已读但是未同步的的文件记录
     * @return
     */
    public List<FileSyncLog> findTodayNeedSyncRecord() {
        return fileSyncLogMapper.findTodayNeedSyncRecord();
    }

}
