package com.bcxin.sp.work.service.sys;

import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.bcxin.sp.work.dao.sys.ConfigApproveLimitMapper;
import com.bcxin.sp.work.dao.sys.ConfigMapper;
import com.bcxin.sp.work.entity.domain.sys.Config;
import com.bcxin.sp.work.entity.domain.sys.ConfigApproveLimit;
import com.bcxin.sp.work.entity.domain.sys.Region;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import com.google.common.collect.Lists;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
@Transactional
public class ConfigService  {

    @Resource
    private RegionService regionService;
    @Resource
    private ConfigMapper configMapper;

    @Resource
    private ConfigApproveLimitMapper configApproveLimitMapper;

    public void insert(Config config){
        configMapper.insert(config);
        ConfigUtil.putValue(config);
    }

    public void update(Config config){
        configMapper.updateById(config);
        ConfigUtil.putValue(config);
    }

    public Config findByKey(String key) {
        List<Config> configList = configMapper.selectList(new EntityWrapper<Config>().eq("syskey", key));
        if (CollectionUtil.isEmpty(configList)) {
            return null;
        }
        return configList.get(0);
    }

    public List<ConfigApproveLimit> approveLimitList() {
        return configApproveLimitMapper.selectAll();
    }
    public List<ConfigApproveLimit> findChildLimitByParentId(Long regionId) {
        List<ConfigApproveLimit> limitList = configApproveLimitMapper.selectAllByRegionId(regionId);
        if(limitList.size()==0){
            limitList = Lists.newArrayList();
            ConfigApproveLimit configApproveLimit;
            List<Region> list = regionService.findByParentId(regionId);
            for (Region region : list){
                configApproveLimit = new ConfigApproveLimit();
                configApproveLimit.setRegionId(region.getId());
                configApproveLimit.setRegionName(region.getFullName());
                configApproveLimit.setApproveLimit(0);
                limitList.add(configApproveLimit);
            }
        }
        return limitList;
    }

    public void updateApproveLimit(Long regionId,int approveLimit, String childLimits){
        configApproveLimitMapper.updateByRegionId(regionId,approveLimit);
        ConfigApproveLimit configApproveLimit;
        if(StringUtils.isNotEmpty(childLimits)){
            String[] arr = childLimits.split(",");
            for (String str : arr){
                String[] arr2 = str.split("_");
                configApproveLimit = configApproveLimitMapper.selectByRegionId(Long.parseLong(arr2[0]));
                if(configApproveLimit == null){
                    configApproveLimit = new ConfigApproveLimit();
                    configApproveLimit.setParentRegionId(regionId);
                    configApproveLimit.setRegionId(Long.parseLong(arr2[0]));
                    configApproveLimit.setApproveLimit(Integer.parseInt(arr2[1]));
                    configApproveLimitMapper.insert(configApproveLimit);
                }else{
                    configApproveLimit.setApproveLimit(Integer.parseInt(arr2[1]));
                    configApproveLimitMapper.updateById(configApproveLimit);
                }
            }
        }
    }
}
