package com.bcxin.sp.work.service.sys;

import com.bcxin.sp.work.dao.activity.base.ActivityMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityMaterialMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityMaterial;
import com.bcxin.sp.work.service.activity.approve.ApproveFileService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * 修复各种业务数据问题
 * @author luopeng
 */
@Service
@Transactional
public class RepairService {

    @Resource
    private ActivityMapper activityMapper;

    @Resource
    private ActivityMaterialMapper activityMaterialMapper;

    @Resource
    private ApproveFileService approveFileService;

    /**
     * 修复许可审批表
     * @return
     */
    public boolean repairAQXKSPB(){
        List<ActivityMaterial> materialList = activityMaterialMapper.findNotEmptyAQXKSPB();
        for (ActivityMaterial material:materialList) {
            Long activityId = material.getActivityId();
            Activity activity = activityMapper.selectById(activityId);
            /* 重新生成许可审批表 */
            approveFileService.generateaqxkspb(activity);
        }
        return true;
    }
}
