package com.bcxin.sp.work.service.sys;

import com.bcxin.sp.work.dao.sys.SPMsgTemplateMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.sys.SPMsgTemplate;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.DictConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class SPMsgTemplateService {

    @Autowired
    private SPMsgTemplateMapper SPMsgTemplateMapper;

    public SPMsgTemplate findById(long id) {
        return SPMsgTemplateMapper.selectById(id);
    }

    public SPMsgTemplate save(SPMsgTemplate SPMsgTemplate, User user) {
        SPMsgTemplate.setProvince(user.getProvince());
        SPMsgTemplate.setCity(user.getCity());
        SPMsgTemplate.setArea(user.getArea());
        SPMsgTemplate.setActive(DictConst.Y);
        SPMsgTemplateMapper.insert(SPMsgTemplate);
        return SPMsgTemplate;
    }


    public SPMsgTemplate findAdministrativeByArea(User user) {
        return this.findAdministrativeByArea(user.getProvince(),user.getCity(),user.getArea());
    }

    public SPMsgTemplate findAdministrativeByArea(Activity activity) {
        return this.findAdministrativeByArea(activity.getProvince(),activity.getCity(),activity.getArea());
    }


    private SPMsgTemplate findAdministrativeByArea(String province, String city, String area) {
        return SPMsgTemplateMapper.selectByArea(province,city,area);
    }

    public void update(SPMsgTemplate SPMsgTemplate) {
        SPMsgTemplateMapper.updateById(SPMsgTemplate);
    }


}
