package com.bcxin.sp.work.service.sys;

import com.bcxin.sp.work.dao.sys.ServiceOrgMapper;
import com.bcxin.sp.work.entity.domain.sys.ServiceOrg;
import com.bcxin.sp.work.entity.dto.ServiceOrgSearchDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * 服务机构
 */
@Service
@Transactional
public class ServiceOrgService {

    @Autowired
    private ServiceOrgMapper serviceOrgMapper;

    public ServiceOrgSearchDto search(ServiceOrgSearchDto searchDto) {

        List<ServiceOrg> list = serviceOrgMapper.search(searchDto);

        Long count = serviceOrgMapper.searchCount(searchDto);

        searchDto.setData(list);
        searchDto.setITotalDisplayRecords(count);
        searchDto.setITotalRecords(count);
        return searchDto;
    }

    public ServiceOrg findById(Long orgId) {
        return serviceOrgMapper.selectById(orgId);
    }

    /**
     * <b> 根据活动id查询安保公司信息 </b>
     * @author ZXF
     * @create 2020/03/03 0003 15:32
     * @version
     * @注意事项 </b>
     */
    public Map getServiceOrgByIdForOne(long activityId) {
        return serviceOrgMapper.getServiceOrgByIdForOne(activityId);
    }
}
