package com.bcxin.sp.work.service.sys;

import com.bcxin.sp.work.dao.sys.SlMsgTemplateMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.sys.SlMsgTemplate;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.DictConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 受理短信模板服务
 */
@Service
@Transactional
public class SlMsgTemplateService {

    @Autowired
    private SlMsgTemplateMapper slMsgTemplateMapper;

    public SlMsgTemplate findById(long id) {
        return slMsgTemplateMapper.selectById(id);
    }

    public SlMsgTemplate save(SlMsgTemplate slMsgTemplate,User user) {
        slMsgTemplate.setProvince(user.getProvince());
        slMsgTemplate.setCity(user.getCity());
        slMsgTemplate.setArea(user.getArea());
        slMsgTemplate.setActive(DictConst.Y);
        slMsgTemplateMapper.insert(slMsgTemplate);
        return slMsgTemplate;
    }


    public SlMsgTemplate findTemplateByArea(User user) {
        return this.findTemplateByArea(user.getProvince(),user.getCity(),user.getArea());
    }

    public SlMsgTemplate findTemplateByArea(Activity activity) {
        return this.findTemplateByArea(activity.getProvince(),activity.getCity(),activity.getArea());
    }

    public SlMsgTemplate findTemplateByArea(String province,String city,String area) {
        return slMsgTemplateMapper.selectByArea(province,city,area);
    }

    public void update(SlMsgTemplate slMsgTemplate) {
        slMsgTemplateMapper.updateById(slMsgTemplate);
    }


}
