package com.bcxin.sp.work.service.telPhoneService;

import cn.hutool.core.collection.CollectionUtil;
import com.bcxin.sp.work.dao.telPhone.TelPhoneMapper;
import com.bcxin.sp.work.entity.domain.user.TelPhone;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author Administrator
 */
@Service
@Transactional
public class TelPhoneService {

    @Autowired
    private TelPhoneMapper telPhoneMapper;

    public int save(TelPhone telPhone) {
        return telPhoneMapper.insert(telPhone);
    }

    public TelPhone selectById(long id) {
        return telPhoneMapper.selectById(id);
    }

    public int update(TelPhone telPhone) {
        return telPhoneMapper.updateById(telPhone);
    }

    public TelPhone selectTelPhoneByLevel(int regionLevel, String place) {
        List<TelPhone> list = telPhoneMapper.selectTelPhoneByLevel(regionLevel, place);
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        return list.get(0);
    }

    public TelPhone instance(int regionLevel, String place){
        TelPhone telPhone = selectTelPhoneByLevel(regionLevel, place);
        if (telPhone == null) {
            return new TelPhone();
        }
        return telPhone;
    }
}
