package com.bcxin.sp.work.service.third.activityIsr;

import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.activity.extend.ActivityBuildItemMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityBuildMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityBuild;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityBuildItem;
import com.bcxin.sp.work.entity.dto.accident.ActivityBuildSearchDTO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Classname ActivityBuildService
 * @Description 活动临建态势
 * @Date 2020/5/9 13:25
 * @Created by wangjianjun
 */
@Service
public class ActivityBuildService{

    @Resource
    private ActivityBuildMapper activityBuildMapper;

    @Resource
    private ActivityBuildItemMapper activityBuildItemMapper;

    /**
     * 活动临建公司信息-列表
     * @param searchDTO
     * @return
     */
    public PageResult findActivityBuildList(ActivityBuildSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityBuild> page = new Page<>(searchDTO.getIDisplayStart()/searchDTO.getIDisplayLength()+1, searchDTO.getIDisplayLength());
        List<ActivityBuild> list = activityBuildMapper.findAllByUpdateTime(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }
    /**
     * 活动临建公司信息-详情
     * @param id
     * @return
     */
    public ActivityBuild selectByPrimaryKey(Long activityBuildId) {
        return activityBuildMapper.selectByPrimaryKey(activityBuildId);
    }


    /**
     * 活动临建信息-列表
     * @param searchDTO
     * @return
     */
    public PageResult findActivityBuildItemList(ActivityBuildSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityBuildItem> page = new Page<>(searchDTO.getIDisplayStart()/searchDTO.getIDisplayLength()+1, searchDTO.getIDisplayLength());
        List<ActivityBuildItem> list = activityBuildItemMapper.findAllByItemTypeAndApproveStatus(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 活动临建信息-详情
     * @param activityBuildItemId
     * @return
     */
    public ActivityBuildItem selectItemByPrimaryKey(Long activityBuildItemId) {
        return activityBuildItemMapper.selectByPrimaryKey(activityBuildItemId);
    }


}
