/**
 * date: 2020-04-26 17:58
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.service.third.activityIsr;

import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.activity.other.AircraftMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.base.Aircraft;
import com.bcxin.sp.work.entity.dto.accident.AircraftSearchDTO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: wangjianjun
 * @description:
 * @data: 2020-04-26 17:58
 **/
@Service
public class AircraftService {

    @Resource
    private AircraftMapper baseAircraftMapper;

    /**
     * 列表
     * @param searchDTO
     * @return
     */
    public PageResult findAirCraftList(AircraftSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<Aircraft> page = new Page<>(searchDTO.getIDisplayStart()/searchDTO.getIDisplayLength()+1, searchDTO.getIDisplayLength());
        List<Aircraft> list = baseAircraftMapper.selectAllByAircraftTypeAndBuyDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 详情
     * @param id
     * @return
     */
    public Aircraft findAircraftDetail(Long id) {
        return baseAircraftMapper.selectByPrimaryKey(id);
    }
}