package com.bcxin.sp.work.service.third.nx;

import com.bcxin.sp.work.dao.third.nx.NXDataMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.nx.NxParamDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 */
@Service("nxDataService")
@Transactional
@Slf4j
public class NXDataService {

    @Resource
    private NXDataMapper nxDataMapper;


    /**
     * 人员盘查记录信息(指挥部_移动盘查)资源表
     */
    public PageResult findRyydpcListData(SearchDto<NxParamDTO> dto) {
        List<Map> list = nxDataMapper.findRyydpcListData(dto);
        Long total = nxDataMapper.findRyydpcListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 场所盘查记录信息(指挥部_移动盘查)资源表
     */
    public PageResult findXgcspcxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findXgcspcxxListData(dto);
        Long total = nxDataMapper.findXgcspcxxListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 涉会企业基本信息
     */
    public PageResult findShqyjbxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findShqyjbxxListData(dto);
        Long total = nxDataMapper.findShqyjbxxListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 人员居住证明信息
     */
    public PageResult findRyjzzmxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findRyjzzmxxListData(dto);
        Long total = nxDataMapper.findRyjzzmxxListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 治安人员过闸信息
     */
    public PageResult findZarygzxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findZarygzxxListData(dto);
        Long total = nxDataMapper.findZarygzxxListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 人员汽车票信息
     */
    public PageResult findRyqcpxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findRyqcpxxListData(dto);
        Long total = nxDataMapper.findRyqcpxxListDataCnt(dto);
        return new PageResult(list, total);
    }

    /**
     * 人员_情报_全国在逃人员信息
     */
    public PageResult findQgztryxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findQgztryxxListData(dto);
        Long total = nxDataMapper.findQgztryxxListDataCnt(dto);
        return new PageResult(list, total);
    }
    /**
     * 人员_情报_全国重点人员信息表
     */
    public PageResult findQgzdryxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findQgzdryxxListData(dto);
        Long total = nxDataMapper.findQgzdryxxListDataCnt(dto);
        return new PageResult(list, total);
    }
    /**
     * 人员_情报_全国刑事犯罪前科人员信息
     */
    public PageResult findQgxsfzqkryxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findQgxsfzqkryxxListData(dto);
        Long total = nxDataMapper.findQgxsfzqkryxxListDataCnt(dto);
        return new PageResult(list, total);
    }
    /**
     * 人员_情报_全国涉稳人员信息
     */
    public PageResult findQgswryxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findQgswryxxListData(dto);
        Long total = nxDataMapper.findQgswryxxListDataCnt(dto);
        return new PageResult(list, total);
    }
    /**
     * 人员_情报_全国涉恐人员信息
     */
    public PageResult findQgskryxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findQgskryxxListData(dto);
        Long total = nxDataMapper.findQgskryxxListDataCnt(dto);
        return new PageResult(list, total);
    }
    /**
     * 车辆_治安_全国被盗抢机动车信息
     */
    public PageResult findQgbdqjdcxxListData(SearchDto<NxParamDTO> dto){
        List<Map> list = nxDataMapper.findQgbdqjdcxxListData(dto);
        Long total = nxDataMapper.findQgbdqjdcxxListDataCnt(dto);
        return new PageResult(list, total);
    }

}
