package com.bcxin.sp.work.startup;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.bcxin.sp.work.dao.sys.ConfigFunctionMapper;
import com.bcxin.sp.work.dao.sys.ConfigMapper;
import com.bcxin.sp.work.entity.domain.sys.Config;
import com.bcxin.sp.work.entity.domain.sys.ConfigFunction;
import com.bcxin.sp.work.entity.dto.ApproveUtil;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
@Slf4j
public class MyStartupRunner implements CommandLineRunner {

	@Resource
	private ConfigMapper configMapper;

	@Resource
	private ConfigFunctionMapper configFunctionMapper;

	@Override
	public void run(String... args) {
		log.info("初始化系统配置...");
		List<Config> configList = configMapper.selectList(new EntityWrapper<Config>());
		for(Config config : configList) {
			ConfigUtil.putValue(config);
			log.info(config.getSysKey()+":"+config.getSysValue());
		}
		List<ConfigFunction> configFunctionList = configFunctionMapper.selectList(new EntityWrapper<ConfigFunction>());
		for(ConfigFunction config : configFunctionList) {
			ConfigUtil.putFunction(config);
		}
		log.info("初始化字典配置...");
		ApproveUtil.putAll();
	}

}
