package com.bcxin.sp.work.util;

import com.alibaba.fastjson.JSON;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.util.Const.GlobalConst;
import lombok.extern.slf4j.Slf4j;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.List;

@Slf4j
public class ImportUtil {
	

	public static List<Activity> parseActivity(File file) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(file));
		String content = reader.readLine();
		log.info("import content:" + content);
		reader.close();
		byte[] buf = DESUtil.decrypt(DESUtil.parseHexStr2Byte(content), GlobalConst.KEY);
		String result = new String(buf);
		log.info("decrypt:" + result);
		List<Activity> data = JSON.parseArray(result, Activity.class);
		return data;
	}
	
	public static String generateData(List<Activity> activityList) throws Exception {
		log.info("data size:" + activityList.size());
		String result = JSON.toJSONString(activityList);
		log.info("data content:" + result);
		byte[] buf = DESUtil.encrypt(result.getBytes(), GlobalConst.KEY);
		result = DESUtil.parseByte2HexStr(buf);
		log.info("encrypt:" + result);
		return result;
	}
	
}
