package com.bcxin.sp.work.util;

import cn.hutool.core.util.StrUtil;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.util.Const.DictConst;
import com.google.common.base.Objects;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.StringUtils;

@Slf4j
public class SearchUtil {
	
	public static StringBuffer getCondition(SearchDto<?> dto,boolean isHistorySearch) throws Exception {
		StringBuffer condition = new StringBuffer();
		if(null != dto) {
            condition.append(" WHERE 1=1 ");
            if(dto.getRegionLevel() == 1) {
                condition.append(" AND a.province = '"+dto.getProvince()+"' ");
            } else if(dto.getRegionLevel() == 2) {
				condition.append(" AND a.city = '"+dto.getCity()+"' ");
			} else if(dto.getRegionLevel() == 3) {
				condition.append(" AND a.city = '"+dto.getCity()+"' ");
				condition.append(" AND a.area = '"+dto.getArea()+"' ");
			}
			if(dto.getGov() != null) {
				if(dto.getGov()) {
					condition.append(" and isBackUp = 1 ");
				} else {
					condition.append(" and isBackUp = 0 ");
				}
			}
			
			if(StringUtil.isNotEmpty(dto.getApproveStatus())) {
				condition.append(" AND approveStatus = '" + dto.getApproveStatus() + "' ");
			}
			if(StringUtil.isNotEmpty(dto.getApproveStatusSummary())) {
            	/* 这是从汇总那边点进来的，初审阶段，受理阶段，审批阶段，审批结果 */
				if ("cs".equals(dto.getApproveStatusSummary()) ) {
					condition.append(" AND approveStatus in ('" + DictConst.STATUS_CSZ + "','" + DictConst.STATUS_CSTG + "','" + DictConst.STATUS_CSXG + "') ");
				} else if ("sl".equals(dto.getApproveStatusSummary())) {
					condition.append(" AND approveStatus in ('" + DictConst.STATUS_SLZ + "','" + DictConst.STATUS_SL + "','" + DictConst.STATUS_BSL + "') ");
				} else if ("sp".equals(dto.getApproveStatusSummary())) {
					condition.append(" AND approveStatus in ('" + DictConst.STATUS_NONE + "','" + DictConst.STATUS_IN + "','" + DictConst.STATUS_REJECT + "') ");
				} else if ("spjg".equals(dto.getApproveStatusSummary())) {
					condition.append(" AND approveStatus in ('" + DictConst.STATUS_YES + "','" + DictConst.STATUS_NO + "') ");
				}
			}
			if(!StringUtils.isEmpty(dto.getSCity())) {
				condition.append(" AND a.city = '" +dto.getSCity()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getSArea())) {
				condition.append(" AND a.area = '" +dto.getSArea()+ "' ");
			}
			//活动创建时间
			if(!StringUtils.isEmpty(dto.getAddTime())) {
				condition.append(" AND DATE_FORMAT(a.addTime,'%Y-%m-%d') = '"+dto.getAddTime()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getEndDate())) {
				condition.append(" AND startDate <= '"+dto.getEndDate()+"' ");
			}
			//活动开始日期
			if(!StringUtils.isEmpty(dto.getStartDate())) {
				condition.append(" AND startDate >= '"+dto.getStartDate()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getEndDate())) {
				condition.append(" AND startDate <= '"+dto.getEndDate()+"' ");
			}
			//活动结束日期
			if(!StringUtils.isEmpty(dto.getFinishStartDate())) {
				condition.append(" AND endDate >= '"+dto.getFinishStartDate()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getFinishEndDate())) {
				condition.append(" AND endDate <= '"+dto.getFinishEndDate()+"' ");
			}
			//同步标记
			if(!StringUtils.isEmpty(dto.getSync())) {
				condition.append(" AND sync = '" +dto.getSync()+ "' ");
			}
			//活动类型
			if(!StringUtils.isEmpty(dto.getTypeCode())) {
				condition.append(" AND typeCode = '" +dto.getTypeCode()+ "' ");
			}
			//报批时间
			if(!StringUtils.isEmpty(dto.getAddTimeStartDate())) {
				condition.append(" AND addTime >= '"+dto.getAddTimeStartDate()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getAddTimeEndDate())) {
				condition.append(" AND addTime <= '"+dto.getAddTimeEndDate()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getKeywords())) {
				if (isHistorySearch) {
					condition.append(" AND (fullName like '%" + dto.getKeywords() + "%' OR address like '%" + dto.getKeywords() + "%' OR u.realName like '%" + dto.getKeywords() + "%' OR u.userName like '%" + dto.getKeywords() + "%' OR sponsor like '%" + dto.getKeywords() + "%') ");
				} else {
					condition.append(" AND (fullName like '%" + dto.getKeywords() + "%' OR address like '%" + dto.getKeywords() + "%' OR sponsor like '%" + dto.getKeywords() + "%') ");
				}
			}
			if (StringUtil.isNotEmpty(dto.getActivityChannel())) {
				condition.append(" and activityChannel = '" + dto.getActivityChannel()+ "'");
			}
		}
		return condition;
	}

	public static StringBuffer getUserCondition(SearchDto<?> dto) throws Exception {
		StringBuffer condition = new StringBuffer();
		if(null != dto) {
		    //TODO  sql注入
			condition.append(" WHERE 1=1 ");
            if(dto.getRegionLevel() == 1) {
                condition.append(" AND province = '"+dto.getProvince()+"' ");
                if (StringUtil.isNotEmpty(dto.getSCity())) {
					condition.append(" AND city = '"+dto.getSCity()+"' ");
				}
				if (StringUtil.isNotEmpty(dto.getSArea())) {
					condition.append(" AND area = '"+dto.getSArea()+"' ");
				}
            } else if(dto.getRegionLevel() == 2) {
                condition.append(" AND province = '"+dto.getProvince()+"' ");
				condition.append(" AND city = '"+dto.getCity()+"' ");
				if (StringUtil.isNotEmpty(dto.getSArea())) {
					condition.append(" AND area = '"+dto.getSArea()+"' ");
				}
			} else if(dto.getRegionLevel() == 3) {
                condition.append(" AND province = '"+dto.getProvince()+"' ");
				condition.append(" AND city = '"+dto.getCity()+"' ");
				condition.append(" AND area = '"+dto.getArea()+"' ");
			}
			if (StrUtil.isNotEmpty(dto.getSWorkRole())){
				condition.append(" AND workRole = '"+dto.getSWorkRole()+"' ");
			}
			/* 如果没有查询条件，则默认取有角色的人员 */
			if (StrUtil.isEmpty(dto.getDataSource())) {
				if (StrUtil.isEmpty(dto.getSRole())){
					condition.append(" AND (workRole is not null and workRole != '') ");
				} else {
					if (dto.getSRole().equals("NONE")) {
						condition.append(" AND (workRole is null or workRole = '') ");
					} else {
						condition.append(" AND role = '" + dto.getSRole() + "' ");
					}
				}
			}
			if (StrUtil.isNotEmpty(dto.getRole())){
				condition.append(" AND role = '"+dto.getRole()+"' ");
			}
			if (StrUtil.isNotEmpty(dto.getAreaCode())){
				if (dto.getAreaCode().endsWith("0000")) {//省
					condition.append(" AND province = '"+dto.getAreaCode()+"' ");
					condition.append(" AND (city = '' or city is null) ");
					condition.append(" AND (area = ''  or area is null)");
				} else if (dto.getAreaCode().endsWith("00")) {//市
					condition.append(" AND city = '"+dto.getAreaCode()+"' ");
					condition.append(" AND (area = ''  or area is null)");
				} else {//区
					condition.append(" AND area = '"+dto.getAreaCode()+"' ");
				}
			}
			if(dto.getActive() != null){
				condition.append(" AND active ="+dto.getActive()+"");
			}
			if(!StringUtils.isEmpty(dto.getKeywords())) {
				condition.append(" AND (username like '%"+dto.getKeywords()+"%' OR realName like '%"+dto.getKeywords()+"%' or policeNumber = '"+dto.getKeywords()+"' ) ");
			}
		}
		log.info("condition: " + condition);
		return condition;
	}
	
	public static StringBuffer getSummaryCondition(SearchDto<?> dto, User currentUser) throws Exception {
		StringBuffer condition = new StringBuffer();
		if(null != dto) {
			condition.append("SELECT province, city, (SELECT r.fullName from base_region r where province=r.id) provincename,");
			condition.append("(SELECT r.fullName from base_region r where city=r.id) cityname,");
			if (dto.getRegionLevel() > 1) {
				condition.append("area, ");
				condition.append("(SELECT r.fullName from base_region r where area=r.id) areaname, ");
			} else if(!StringUtils.isEmpty(dto.getSArea())) {
				//市级以上搜索区县
				condition.append("area, ");
				condition.append("(SELECT r.fullName from base_region r where area=r.id) areaname, ");
			}
			condition.append("  SUM(CASE WHEN typeCode='100006' THEN amount ELSE 0 END) AS 'charity', ");
			condition.append("  SUM(CASE WHEN typeCode='100003' THEN amount ELSE 0 END) AS 'exhibition', ");
			condition.append("  SUM(CASE WHEN typeCode='100005' THEN amount ELSE 0 END) AS 'recruit', ");
			condition.append("  SUM(CASE WHEN typeCode='100004' THEN amount ELSE 0 END) AS 'gardenlantern', ");
			condition.append("  SUM(CASE WHEN typeCode='100002' THEN amount ELSE 0 END) AS 'literature', ");
			condition.append("  SUM(CASE WHEN typeCode='100001' THEN amount ELSE 0 END) AS 'sport', ");
			condition.append("  SUM(CASE WHEN typeCode='100007' THEN amount ELSE 0 END) AS 'other', ");
			condition.append("  SUM(CASE WHEN typeCode='gongan' THEN amount ELSE 0 END) AS 'gonganBeian' ");
			condition.append(" FROM ( ");
			condition.append(" SELECT province, city, ");
			if (dto.getRegionLevel() > 1) {
				condition.append("area, ");
			} else if(!StringUtils.isEmpty(dto.getSArea())) {
				//市级以上搜索区县
				condition.append("area, ");
			}
			condition.append(" typeCode, count(id) as amount FROM sp_activity ");
			condition.append("  WHERE 1=1 ");
			if (dto.getRegionLevel() == 1) {
				condition.append(" and province = '" + dto.getProvince() + "' ");
		    } else if(dto.getRegionLevel() == 3) {
				condition.append(" AND city = '"+dto.getCity()+"' ");
				condition.append(" AND area = '"+dto.getArea()+"' ");
			} else if(dto.getRegionLevel() == 2) {
				condition.append(" AND city = '"+dto.getCity()+"' ");
			}
			if (dto.getGov() != null) {
				if (dto.getGov()) {
					condition.append(" AND isBackUp = 1 ");
				} else {
					condition.append(" AND isBackUp = 0 ");
				}
			}
			if(!StringUtils.isEmpty(dto.getSProvince())) {
				condition.append(" AND province = '" +dto.getSProvince()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getSCity())) {
				condition.append(" AND city = '" +dto.getSCity()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getSArea())) {
				condition.append(" AND area = '" +dto.getSArea()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getStartDate())) {
				condition.append(" AND startDate >= '"+dto.getStartDate().trim()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getEndDate())) {
				condition.append(" AND startDate <= '"+dto.getEndDate().trim()+"' ");
			}

			if (!(Objects.equal(DictConst.ROLE_SUPERADMIN, currentUser.getRole())
				|| Objects.equal(DictConst.ROLE_ADMIN, currentUser.getRole())
				|| Objects.equal(DictConst.ROLE_ADMIN_APPROVE, currentUser.getRole())
				|| Objects.equal(DictConst.ROLE_EXPORT, currentUser.getRole())
				|| Objects.equal(DictConst.ROLE_READ, currentUser.getRole()) || Objects.equal(DictConst.ROLE_DOWNLOAD, currentUser.getRole()))) {
				condition.append("AND approveLevel = "+currentUser.getRegionLevel()+" ");
			}

			condition.append(" group by province,city,typeCode ");
			if(dto.getRegionLevel() > 1) {
				condition.append(", area ");
			}else if(!StringUtils.isEmpty(dto.getSArea())) {
				//市级以上搜索区县
				condition.append(", area ");
			}


			// 增加历史数据统计sql
			condition.append(" union all ");
			condition.append(" select province,city, ");
			if (dto.getRegionLevel() > 1) {
				condition.append("area, ");
			}else if(!StringUtils.isEmpty(dto.getSArea())) {
				//市级以上搜索区县
				condition.append("area, ");
			}
			condition.append(" 'gongan' as typeCode,count(id) AS amount from sp_activity_history");

			condition.append("  WHERE 1=1 ");
			if (dto.getRegionLevel() == 1) {
				condition.append(" and province = '" + dto.getProvince() + "' ");
			} else if(dto.getRegionLevel() == 3) {
				condition.append(" AND city = '"+dto.getCity()+"' ");
				condition.append(" AND area = '"+dto.getArea()+"' ");
			} else if(dto.getRegionLevel() == 2) {
				condition.append(" AND city = '"+dto.getCity()+"' ");
			}

			if(!StringUtils.isEmpty(dto.getSProvince())) {
				condition.append(" AND province = '" +dto.getSProvince()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getSCity())) {
				condition.append(" AND city = '" +dto.getSCity()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getSArea())) {
				condition.append(" AND area = '" +dto.getSArea()+ "' ");
			}
			if(!StringUtils.isEmpty(dto.getStartDate())) {
				condition.append(" AND startDate >= '"+dto.getStartDate().trim()+"' ");
			}
			if(!StringUtils.isEmpty(dto.getEndDate())) {
				condition.append(" AND startDate <= '"+dto.getEndDate().trim()+"' ");
			}

			condition.append(" group by province,city ");
			if(dto.getRegionLevel() > 1) {
				condition.append(", area ");
			}else if(!StringUtils.isEmpty(dto.getSArea())) {
				//市级以上搜索区县
				condition.append(", area ");
			}

			condition.append(") T ");
			condition.append(" GROUP BY province, city ");
			if(dto.getRegionLevel() > 1) {
				condition.append(", area");
			}else if(!StringUtils.isEmpty(dto.getSArea())) {
				//市级以上
				condition.append(", area ");
			}
		}
		log.info("condition: " + condition);
		return condition;
	}
	
}
